package org.processmining.plugins.fuzzymap;

import java.util.ArrayList;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.connections.annotations.ConnectionObjectFactory;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.graphbased.directed.patterntree.PatternTree;
import org.processmining.plugins.abstractions.PatternAbstractionFrame;

@Plugin(name = "Fuzzy Map Connection Factory", parameterLabels = { "Pattern Tree", "Pattern Abstraction Frame",
		"Filtered Pattern AlphabetSet", "Log", "Mining Parameters" }, returnTypes = FuzzyMapConnection.class, returnLabels = "Fuzzy Map Connection", userAccessible = false)
@ConnectionObjectFactory
public class FuzzyMapConnection extends AbstractConnection {
	public final static String PATTERN_TREE = "Pattern Tree";
	public final static String PATTERN_ABSTRACTION_FRAME = "pattern Abstraction Frame";
	public final static String FILTERED_PATTERN_ALPHABETSET = "Filtered Pattern AlphabetSet";
	public final static String LOG = "log";
	public final static String MINING_PARAMETERS = "MiningParameters";

	public FuzzyMapConnection(PatternTree patterntree, PatternAbstractionFrame ptnAbsFrm,
			Set<Set<String>> filterPatternAlphabetSet, XLog log, ArrayList<Object> miningParas) {
		super("FuzzyMapConnection");
		put(PATTERN_TREE, patterntree);
		put(PATTERN_ABSTRACTION_FRAME, ptnAbsFrm);
		put(FILTERED_PATTERN_ALPHABETSET, filterPatternAlphabetSet);
		put(LOG, log);
		put(MINING_PARAMETERS, miningParas);
		//	put(CHAR_ACTIVITY_MAP,charActivityMap);
		//put(ENCODED_TRACE_LIST,encodeTraceList);
		System.out.println("FuzzyMapConnection Created successfully!!!");
	}
}
