package org.processmining.plugins.fuzzymap.miner;

import java.util.ArrayList;
import java.util.Set;
import java.util.concurrent.CancellationException;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.patterntree.PatternTree;
import org.processmining.plugins.abstractions.PatternAbstractionFrame;
import org.processmining.plugins.fuzzymap.ui.FuzzyMapMinerConfigurationUI;

@Plugin(name = "Fuzzy Map Miner", parameterLabels = { "Log" }, returnLabels = { "Fuzzy Map Toolkit",
		"FilteredPatternAlphabetSequenceMap", "AbstractionSequenceMap", "log", "Mining Parameter" }, returnTypes = {
		PatternTree.class, PatternAbstractionFrame.class, Set.class, XLog.class, ArrayList.class })
public class FuzzyMapMiner {

	//**************** 3 Variants without nets **********************//
	//@UITopiaVariant(uiLabel = "Fuzzy Map Miner", affiliation = UITopiaVariant.EHV, author = "Jiafei Li ", email = "jiafei@jlu.edu.cn")
	@PluginVariant(variantLabel = "Default event log classes", requiredParameterLabels = { 0 })
	public Object[] doPreProcessing(final UIPluginContext context, XLog log) throws CancellationException {
		FuzzyMapMinerConfigurationUI miner = new FuzzyMapMinerConfigurationUI(context, log);
		Object[] a = miner.preprocess(log);
		return a;
	}
}