package org.processmining.plugins.fuzzymap.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.util.List;
import java.util.Set;

import javax.swing.BorderFactory;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.Progress;
import org.processmining.models.graphbased.directed.patterntree.PatternTree;
import org.processmining.plugins.abstractions.PatternAbstractionFrame;
import org.processmining.plugins.ptnBasedPreprocess.util.PatternAbstractionFrameUtil;

import com.fluxicon.slickerbox.components.GradientPanel;

public class FuzzyMapToolkitPanel extends GradientPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2247777900562090661L;
	protected UIPluginContext context;
	protected Progress progress;
	protected XLog log;
	protected Color background = new Color(100, 100, 100);
	protected Color canvasBackground = Color.WHITE;
	//	protected PatternTree patternTree;
	protected AbstractionTreePanel abstractionTreePanel;

	//	protected FuzzyModelInformationPanel editorPanel;
	//protected List<Object> miningParameters = new ArrayList<Object>();

	public FuzzyMapToolkitPanel(UIPluginContext context, PatternTree patternTree, PatternAbstractionFrameUtil ptnAbsFrm,
			Set<Set<String>> filterPatternAlphabetSet, XLog log, List<Object> miningParas) {
		super(new Color(60, 60, 60), new Color(20, 20, 20));
		progress = context.getProgress();
		this.context = context;
		setupUI(patternTree, ptnAbsFrm, filterPatternAlphabetSet, log, miningParas);

	}

	public void setupUI(PatternTree patternTree, PatternAbstractionFrameUtil ptnAbsFrm,
			Set<Set<String>> filterPatternAlphabetSet, XLog log, List<Object> miningParas) {
		setDoubleBuffered(true);
		setLayout(new BorderLayout());
		setBorder(BorderFactory.createEmptyBorder());
		abstractionTreePanel = new AbstractionTreePanel(context, this, patternTree, ptnAbsFrm,
				filterPatternAlphabetSet, log, miningParas);
		this.add(abstractionTreePanel, BorderLayout.CENTER);
	}
}
