package org.processmining.plugins.fuzzymodel.miner;

import java.util.concurrent.CancellationException;

import javax.swing.UIManager;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.fuzzymodel.MutableFuzzyGraph;
import org.processmining.plugins.fuzzymodel.miner.ui.FuzzyMinerUI;

@Plugin(name = "Fuzzy Miner", parameterLabels = { "Log", "Summary" }, returnLabels = { "Fuzzy Model"}, returnTypes = {
		 MutableFuzzyGraph.class})
public class FuzzyMiner {

	//**************** 3 Variants without nets **********************//
	@UITopiaVariant(uiLabel = "Fuzzy Miner", affiliation = UITopiaVariant.EHV, author = "Christian W. Guenther and Jiafei Li ", email = "jiafei@jlu.edu.cn")
	@PluginVariant(variantLabel = "Default event classes", requiredParameterLabels = { 0 })
	public  MutableFuzzyGraph doMining(final UIPluginContext context, XLog log) throws CancellationException {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}
		FuzzyMinerUI miner = new FuzzyMinerUI(context);
		MutableFuzzyGraph a = miner.mine(log);
		return a;
	}

}
