package org.processmining.plugins.ptnBasedPreprocess;

import org.processmining.framework.connections.annotations.ConnectionObjectFactory;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.plugins.ptnBasedPreprocess.ui.PatternGraphUI;

@Plugin(name = "Pattern Based Preprocess Connection Factory", parameterLabels = { "Pattern Graph" }, returnTypes = PatternGraphUI.class, returnLabels = "Pattern Based Preprocess Connection", userAccessible = false)
@ConnectionObjectFactory
public class PatternBasedPreprocessConnection extends AbstractConnection {
	public final static String PATTERN_GRAPH = "Pattern Graph";

	public PatternBasedPreprocessConnection(PatternGraphUI graphUI) {
		super("PatternBasedPreprocessConnection");
		put(PATTERN_GRAPH, graphUI);
	}
}

/*
 * @Plugin(name = "Pattern Based Preprocess Connection Factory", parameterLabels
 * = { "Pattern Graph", "Pattern Abstraction Frame",
 * "Filtered Pattern AlphabetSet", "Log"}, returnTypes =
 * PatternBasedPreprocessConnection.class, returnLabels =
 * "Pattern Based Preprocess Connection", userAccessible = false)
 * 
 * @ConnectionObjectFactory public class PatternBasedPreprocessConnection
 * extends AbstractConnection { public final static String PATTERN_TREE=
 * "Pattern Tree"; public final static String PATTERN_ABSTRACTION_FRAME =
 * "pattern Abstraction Frame"; public final static String
 * FILTERED_PATTERN_ALPHABETSET = "Filtered Pattern AlphabetSet"; public final
 * static String LOG = "log";
 * 
 * 
 * 
 * public PatternBasedPreprocessConnection(PatternTree patterntree,
 * PatternAbstractionFrame ptnAbsFrm, Set<Set<String>> filterPatternAlphabetSet,
 * XLog log){ super("PatternBasedPreprocessConnection"); put(PATTERN_TREE,
 * patterntree); put(PATTERN_ABSTRACTION_FRAME,ptnAbsFrm);
 * put(FILTERED_PATTERN_ALPHABETSET,filterPatternAlphabetSet); put(LOG,log); //
 * put(CHAR_ACTIVITY_MAP,charActivityMap);
 * //put(ENCODED_TRACE_LIST,encodeTraceList);
 * System.out.println("PatternBasedPreprocessConnection Created successfully!!!"
 * ); } }
 */
