package org.processmining.plugins.ptnBasedPreprocess;

import org.processmining.models.graphbased.directed.patterntree.PatternTree;

/**
 * @author Jiafei Li
 * @email jiafei@jlu.edu.cn
 * @version Mar 8, 2010
 */

public class PatternTreeFactory {

	private PatternTreeFactory() {
	}

	public static PatternTree newFuzzyMap(String label) {
		return new PatternTreeImpl(label);
	}

	public static PatternTree cloneFuzzyMap(PatternTree diagram) {
		PatternTreeImpl newDiagram = new PatternTreeImpl(diagram.getLabel());
		newDiagram.cloneFrom(diagram);
		return newDiagram;
	}
}