package org.processmining.plugins.ptnBasedPreprocess.plugin;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.ptnBasedPreprocess.PatternBasedPreprocessConnection;
import org.processmining.plugins.ptnBasedPreprocess.ui.PatternGraphUI;

@Plugin(name = "Pattern Based Log Preprocessing", parameterLabels = { "log" }, returnLabels = { "Pattern Graph" }, returnTypes = { PatternGraphUI.class }, userAccessible = true)
public class PatternBasedPreprocessPlugIn {
//	@UITopiaVariant(uiLabel = "Pattern Based Log Preprocessing", affiliation = UITopiaVariant.EHV, author = "Jiafei Li ", email = "jiafei@jlu.edu.cn")
	@PluginVariant(variantLabel = "Default event log classes", requiredParameterLabels = { 0 })
	public static PatternGraphUI patternGraph(UIPluginContext context, XLog log) {
		// Set the look at feel for the alignment frame
		/*
		 * try {
		 * UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		 * } catch (Exception e) { e.printStackTrace(); }
		 */
		PatternGraphUI patternGraphPanel = new PatternGraphUI(context, log);
		context.addConnection(new PatternBasedPreprocessConnection(patternGraphPanel));
		return patternGraphPanel;
	}
}
