package org.processmining.plugins.ptnBasedPreprocess.ui;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeLiteral;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.buffered.XAttributeMapBufferedImpl;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.deckfour.xes.model.impl.XAttributeMapImpl;
import org.deckfour.xes.out.XesXmlGZIPSerializer;
import org.jgraph.event.GraphSelectionEvent;
import org.jgraph.event.GraphSelectionListener;
import org.jgraph.graph.GraphSelectionModel;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.fuzzymodel.MutableFuzzyGraph;
import org.processmining.models.graphbased.directed.jgraph.JGraphVisualizationPanel;
import org.processmining.models.graphbased.directed.jgraph.ProMJGraph;
import org.processmining.models.graphbased.directed.jgraph.ProMJGraphVisualizer;
import org.processmining.models.graphbased.directed.jgraph.elements.ProMGraphCell;
import org.processmining.models.graphbased.directed.patterntree.PatternTreeEdge;
import org.processmining.models.graphbased.directed.patterntree.PatternTreeNode;
import org.processmining.plugins.abstractions.PatternAbstractionFrame;
import org.processmining.plugins.abstractions.swingx.ErrorDialog;
import org.processmining.plugins.abstractions.swingx.ScrollableGridLayout;
import org.processmining.plugins.abstractions.util.EquivalenceClass;
import org.processmining.plugins.abstractions.util.FileIO;
import org.processmining.plugins.abstractions.util.UkkonenSuffixTree;
import org.processmining.plugins.fuzzymap.util.FuzzyMapUtil;
import org.processmining.plugins.ptnBasedPreprocess.PatternTreeImpl;
import org.processmining.plugins.ptnBasedPreprocess.util.PatternAbstractionFrameUtil;
import org.processmining.plugins.ptnBasedPreprocess.util.PatternBasedPreprocessUtil;

import com.fluxicon.slickerbox.components.HeaderBar;
import com.fluxicon.slickerbox.components.SlickerButton;
import com.fluxicon.slickerbox.ui.SlickerRadioButtonUI;
import com.jgraph.layout.JGraphFacade;
import com.jgraph.layout.hierarchical.JGraphHierarchicalLayout;
import com.jgraph.layout.hierarchical.model.JGraphHierarchyModel;

public class PatternGraphUI extends JPanel {

	private static final long serialVersionUID = -3751299572607459175L;
	protected static final boolean DEBUG = false;
	protected static final int NOT_USE_YET = 0;
	protected static final int SINGLE_PATTERN_MODE = 1;
	protected static final int ABSTRACTION_MODE = 2;
	protected static final int CHAR_COUNT_PER_LINE = 30;
	//protected static final String[] illegalCharSetsInFileName =["\","/"];
	//protected String outputDir = "D:\\TransformedLog\\";
	protected String outputDir;
	protected File outputDirectory;
	protected Color background = new Color(100, 100, 100);
	protected PatternTreeImpl patternTree;
	protected Set<Set<String>> filterPatternAlphabetSet;
	protected Set<Set<String>> notUsedSingleActivityInPatternSet;
	protected Set<String> activityToFilterOutSet;
	//keep the map between the new pattern name and its encoded alphabet in current pattern graph
	protected HashMap<String, Set<Set<String>>> newOldPatternNameMap;
	protected HashMap<Set<String>, String> oldNewPatternNameMap;
	//Map between the pattern (encoded) and the  count of its total occurrence in the non-overlapping condition
	protected HashMap<String, Double> patternTotalNonOverlapAlphabetCountMap;
	Map<TreeSet<String>, Integer> actualNonOverlapAlphabetConservednessMetricMap;
	//Map between the pattern (encoded) and the count of its isolation occurrence in the non-overlapping condition
	protected Map<TreeSet<String>, Integer> patternIsolationNonOverlapAlphabetCountMap;
	protected HashMap<String, List<String>> ptnLabelDecodedActivityNameMap;
	protected Map<Set<String>, TreeSet<String>> patAlphabetSeqMap;
	protected Map<Set<String>, TreeSet<String>> absSeqMap;
	protected Map<TreeSet<String>, Integer> actualNonOverlapAlphabetCountMap;
	protected Map<String, Integer> encodedActivityCountMap;
	//Map between the new label of each selected pattern and its alphabet
	protected HashMap<String, Set<Set<String>>> selectedPatternNameAlphabetMap;
	//Map between the new label of each selected pattern and its possible sequences
	protected HashMap<String, Set<String>> selectedPatternNameSequenceMap;
	//Map between the parent pattern and its offspring patterns
	//protected Map<Set<String>,Set<Set<String>>> parentOffspringsPatternMap;
	//Map between the parent pattern and its offspring pattern nodes
	protected Map<PatternTreeNode, Set<PatternTreeNode>> parentOffspringNodesMap;
	//the set of the current selected pattern to use
	private final Set<Set<String>> oldLabelsOfSelectedPatterns;
	//map between selected pattern alphabet and its new pattern label
	private final Map<Set<String>, String> selectedPatternAlphabetNewLabel;

	//protected Map<Integer, Set<PatternTreeNode>> sizeAlphabetSetMap;
	//protected int[] sortedSizeArray;

	protected List<String> encodedTraceList;
	protected UIPluginContext context;
	protected XLog log;
	protected JPanel wholePanel;
	protected JGraphVisualizationPanel graphPanel;
	//protected JPanel graphContainedPanel;
	protected JPanel wholeEditPanel;
	private JPopupMenu popupMenu;
	protected JScrollPane wholeEditScrollPane;
	protected JPanel editPanel;
	protected JPanel desiredPatternPanel;
	protected JPanel filterPatternPanel;
	protected JCheckBox frequencyFilterCheckBox, totalOccurenceCountFilterCheckBox,
			isolationOccurenceCountFilterCheckBox, conservednessFilterCheckBox, alphabetSizeFilterCheckBox;
	protected JTextField nameField;
	protected JLabel nameLabel;
	protected JLabel activityLabel;
	protected JList activityList;
	protected DefaultListModel activityListModel;
	protected JRadioButton notToUseRadioButton;
	protected JRadioButton desireNodeRadioButton;
	protected JRadioButton desireSubGraphRadioButton;
	protected JLabel patternLabel;
	protected JList patternList;
	protected DefaultListModel patternListModel;
	protected JRadioButton selectAllRadioButton;
	protected JRadioButton deselectAllRadioButton;
	protected Map<String, String> charActivityMap;
	protected List<String> encodeTraceList;
	//protected PatternAbstractionFrame ptnAbsFrm;
	protected PatternAbstractionFrameUtil ptnAbsFrm;
	protected PatternTreeNode selectedPatternNode;
	protected String beforeModifiedPatterLabel;
	//private Set<String> newLabelsOfSelectedPattern;
	static int encodingLength;
	protected Boolean isThereDuplicatePattern = false;
	protected String orinalLabelOfCurrentPattern;
	protected int minActivityFrequencyThreshold = 0;
	protected int minTotalOccurenceCountThreshold = 0;
	protected int minIsolationOccurenceCountThreshold = 0;
	protected int minAlphabetSize = 0;
	protected float minConservednessThreshold = 50;
	protected Boolean enableRedraw;
	protected Integer timeToFormTranformerPanel = 0;

	//private LogRelations originLogRelations; // log relations

	public PatternGraphUI(UIPluginContext context, XLog log) {
		this.context = context;
		this.log = log;
//		outputDirectory = new File(outputDir);
//		outputDirectory.mkdir();

		filterPatternAlphabetSet = new HashSet<Set<String>>();
		notUsedSingleActivityInPatternSet = new HashSet<Set<String>>();
		ptnAbsFrm = new PatternAbstractionFrameUtil(context, log);
		ptnAbsFrm.findRepeatPatternsInLog();
		encodingLength = ptnAbsFrm.getEncodingLength();

		actualNonOverlapAlphabetCountMap = ptnAbsFrm.getNonOverlapAlphabetCountMap();
		charActivityMap = new HashMap<String, String>();
		charActivityMap = ptnAbsFrm.getCharActivityMap();
		encodedActivityCountMap = new HashMap<String, Integer>();
		encodedActivityCountMap = ptnAbsFrm.getEncodedActivityCountMap();
		
		actualNonOverlapAlphabetConservednessMetricMap = ptnAbsFrm.getActualNonOverlapAlphabetConservednessMetricMap();

		//set the initial pattern graph according to special values
		filterPatternAlphabetSet = ptnAbsFrm.getFilterPatternAlphabetSet(0,0,50,0);
		//get filtered pattern and its alphabet sequence set map
		patAlphabetSeqMap = ptnAbsFrm.getFilterPatternAlphabetSequenceSetMap(filterPatternAlphabetSet);
		//get abstraction and its alphabet sequence set map
		absSeqMap = ptnAbsFrm.getAbstractionAlphabetSequenceSetMap(filterPatternAlphabetSet);
		//using the longer pattern first
		//ptnAbsFrm.findNonoverlapPatternCountAcrossAllPatterns(false);
		ptnAbsFrm.findNonoverlapPatternCountAcrossAllPatterns(true);
		patternIsolationNonOverlapAlphabetCountMap = ptnAbsFrm.getActualStandAloneAlphabetCountMap();
		for (TreeSet<String> alphabet : actualNonOverlapAlphabetCountMap.keySet()) {
			if (!patternIsolationNonOverlapAlphabetCountMap.containsKey(alphabet)) {
				patternIsolationNonOverlapAlphabetCountMap.put(alphabet, 0);
			}
		}
		//get initial pattern tree which the label of each node is encoded
		String treeLabel = "Pattern Tree of the log " + XConceptExtension.instance().extractName(log);
		notUsedSingleActivityInPatternSet = ptnAbsFrm.getSingleActivityNotUsedInPatterns(filterPatternAlphabetSet,
				encodedActivityCountMap);
		patternTree = new PatternTreeImpl(filterPatternAlphabetSet, notUsedSingleActivityInPatternSet,
				encodedActivityCountMap, actualNonOverlapAlphabetCountMap, patternIsolationNonOverlapAlphabetCountMap,
				actualNonOverlapAlphabetConservednessMetricMap, ptnAbsFrm, treeLabel, encodingLength);

		encodeTraceList = new ArrayList<String>();
		encodeTraceList = ptnAbsFrm.getEncodedTraceList();
		newOldPatternNameMap = new HashMap<String, Set<Set<String>>>();
		oldNewPatternNameMap = new HashMap<Set<String>, String>();
		ptnLabelDecodedActivityNameMap = new HashMap<String, List<String>>();
		patternTotalNonOverlapAlphabetCountMap = new HashMap<String, Double>();
		parentOffspringNodesMap = new HashMap<PatternTreeNode, Set<PatternTreeNode>>();
		oldLabelsOfSelectedPatterns = new HashSet<Set<String>>();
		selectedPatternNameAlphabetMap = new HashMap<String, Set<Set<String>>>();
		selectedPatternNameSequenceMap = new HashMap<String, Set<String>>();
		selectedPatternAlphabetNewLabel = new HashMap<Set<String>, String>();
		activityToFilterOutSet = new HashSet<String>();

		//enableRedraw = false;
		setupUI();
		timeToFormTranformerPanel++;
		redrawGraph(false);
		setGraphListeners();

		//setupPopMenu();
		//enableRedraw = true;
	}

	public void redrawGraph(boolean isUpdateFilterParameters) {
		/*
		 * if (enableRedraw == false) { return; // ignore }
		 */
		if (isUpdateFilterParameters) {
			patternTree.initializeGraph(filterPatternAlphabetSet, notUsedSingleActivityInPatternSet);
			//Set edges for Pattern Graph
			//patternTree.setEdges();
			patternTree.setBasicEdges(filterPatternAlphabetSet);
			patternTree.setExtraEdges();
			patternTree.addNotUsedSingleActivityNodes(notUsedSingleActivityInPatternSet);
			//When redraw the pattern graph, we need to clear contents in these maps
			newOldPatternNameMap.clear();
			oldNewPatternNameMap.clear();
			ptnLabelDecodedActivityNameMap.clear();
			patternTotalNonOverlapAlphabetCountMap.clear();
			patAlphabetSeqMap.clear();
			selectedPatternNameAlphabetMap.clear();
			selectedPatternNameSequenceMap.clear();
			parentOffspringNodesMap.clear();
			oldLabelsOfSelectedPatterns.clear();
			selectedPatternAlphabetNewLabel.clear();

			renamePatternTreeNodes();
			patternTree.setLayedOut(false);
			patternTree.signalViews();

			//reset the component's value 
			resetGUIAttribute();
			patAlphabetSeqMap = ptnAbsFrm.getFilterPatternAlphabetSequenceSetMap(filterPatternAlphabetSet);

		} else if (timeToFormTranformerPanel == 1) {
			//Set edges for Pattern Graph
			//	patternTree.setEdges();
			patternTree.setBasicEdges(filterPatternAlphabetSet);
			patternTree.setExtraEdges();
			patternTree.addNotUsedSingleActivityNodes(notUsedSingleActivityInPatternSet);
			renamePatternTreeNodes();
			//patternTree.signalViews();
		}

		if (graphPanel == null) {
			graphPanel = ProMJGraphVisualizer.visualizeGraph(patternTree);
			ProMJGraph jgraph = graphPanel.getGraph();
			//change the layout of the graph
			//JF comment start 
//			JGraphHierarchicalLayout layout = new JGraphHierarchicalLayout();
//			layout.setOrientation(SwingConstants.WEST);
//			layout.setCompactLayout(true);
//			layout.setInterRankCellSpacing(40);
//			layout.setInterHierarchySpacing(10);
//			layout.setIntraCellSpacing(10);       
//			layout.setDeterministic(false);
//			layout.setFineTuning(true);
//			layout.setParallelEdgeSpacing(20);
//
//			jgraph.setUpdateLayout(layout);
			//JF comment end 
			JGraphHierarchicalLayout layout = new JGraphHierarchicalLayout();
			layout.setOrientation(SwingConstants.WEST);
			JGraphFacade facade = new JGraphFacade(jgraph);
			JGraphHierarchyModel hmdl = new JGraphHierarchyModel(facade,patternTree.getNodes().toArray(),false,true);

			wholePanel.add(graphPanel, BorderLayout.CENTER);
		}
	}

	private void buildFilterPatternPanel() {
		filterPatternPanel = new JPanel();
		filterPatternPanel.setBorder(BorderFactory.createEtchedBorder());
		filterPatternPanel.setBackground(background);
		filterPatternPanel.setVisible(true);

		GridBagLayout filterPatternGBLayout = new GridBagLayout();
		filterPatternPanel.setLayout(filterPatternGBLayout);

		final GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.anchor = GridBagConstraints.CENTER;

		JLabel filterPatternLabel = new JLabel("Smart Filter");
		filterPatternLabel.setFont(filterPatternLabel.getFont().deriveFont(15f));
		filterPatternLabel.setHorizontalAlignment(JLabel.CENTER);
		filterPatternLabel.setHorizontalTextPosition(JLabel.CENTER);
		filterPatternLabel.setAlignmentX(JLabel.CENTER_ALIGNMENT);
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 2;
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(filterPatternLabel, c);
		//Activity Frequency
		frequencyFilterCheckBox = new JCheckBox("Activity Frequency");
		frequencyFilterCheckBox.setSelected(false);
		frequencyFilterCheckBox.setOpaque(false);

		final JSlider frequencyFilterSlider = new JSlider(JSlider.HORIZONTAL, 0, 100, 0);
		frequencyFilterSlider.setEnabled(false);
		frequencyFilterSlider.setOpaque(false);
		Dimension d = frequencyFilterSlider.getPreferredSize();
		frequencyFilterSlider.setPreferredSize(new Dimension(d.width / 2, d.height));

		final JLabel frequencyFilterValueLabel = new JLabel("0");
		frequencyFilterValueLabel.setEnabled(false);
		frequencyFilterValueLabel.setOpaque(false);

		frequencyFilterCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (frequencyFilterCheckBox.isSelected()) {
					frequencyFilterSlider.setEnabled(true);
					frequencyFilterValueLabel.setEnabled(true);
					minActivityFrequencyThreshold = frequencyFilterSlider.getValue();
				} else {
					frequencyFilterSlider.setEnabled(false);
					frequencyFilterValueLabel.setEnabled(false);
					minActivityFrequencyThreshold = 0;
				}
				preparePatternGraphInfo();
				redrawGraph(true);
			}
		});

		frequencyFilterSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				frequencyFilterValueLabel.setText(frequencyFilterSlider.getValue() + "");
				if (!frequencyFilterSlider.getValueIsAdjusting()) {
					minActivityFrequencyThreshold = frequencyFilterSlider.getValue();
					preparePatternGraphInfo();
					redrawGraph(true);
				}
			}
		});

		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(frequencyFilterCheckBox, c);

		c.gridx = 1;
		c.gridy = 1;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(frequencyFilterSlider, c);

		c.gridx = 2;
		c.gridy = 1;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(frequencyFilterValueLabel, c);

		//total Occurrence Count
		totalOccurenceCountFilterCheckBox = new JCheckBox("Non-Overlapping Alphabet Count");
		totalOccurenceCountFilterCheckBox.setSelected(false);
		totalOccurenceCountFilterCheckBox.setOpaque(false);

		final JSlider totalOccurenceCountFilterSlider = new JSlider(JSlider.HORIZONTAL, 0, 100, 0);
		totalOccurenceCountFilterSlider.setEnabled(false);
		d = totalOccurenceCountFilterSlider.getPreferredSize();
		totalOccurenceCountFilterSlider.setPreferredSize(new Dimension(d.width / 2, d.height));
		totalOccurenceCountFilterSlider.setOpaque(false);

		final JLabel totalOccurenceCountFilterValueLabel = new JLabel("0");
		totalOccurenceCountFilterValueLabel.setEnabled(false);
		totalOccurenceCountFilterValueLabel.setOpaque(false);

		totalOccurenceCountFilterCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (totalOccurenceCountFilterCheckBox.isSelected()) {
					totalOccurenceCountFilterSlider.setEnabled(true);
					totalOccurenceCountFilterValueLabel.setEnabled(true);
					minTotalOccurenceCountThreshold = totalOccurenceCountFilterSlider.getValue();
				} else {
					totalOccurenceCountFilterSlider.setEnabled(false);
					totalOccurenceCountFilterValueLabel.setEnabled(false);
					minTotalOccurenceCountThreshold = 0;
				}
				preparePatternGraphInfo();
				redrawGraph(true);
			}
		});

		totalOccurenceCountFilterSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				totalOccurenceCountFilterValueLabel.setText(totalOccurenceCountFilterSlider.getValue() + "");
				if (!totalOccurenceCountFilterSlider.getValueIsAdjusting()) {
					minTotalOccurenceCountThreshold = totalOccurenceCountFilterSlider.getValue();
					preparePatternGraphInfo();
					redrawGraph(true);
				}
			}
		});

		c.gridx = 0;
		c.gridy = 2;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(totalOccurenceCountFilterCheckBox, c);

		c.gridx = 1;
		c.gridy = 2;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(totalOccurenceCountFilterSlider, c);

		c.gridx = 2;
		c.gridy = 2;
		c.gridwidth = 1;
		c.insets = new Insets(5, 0, 0, 10);
		filterPatternPanel.add(totalOccurenceCountFilterValueLabel, c);

		//Isolation Occurrence Count
		isolationOccurenceCountFilterCheckBox = new JCheckBox("Non-Overlapping Global Alphabet Count");
		isolationOccurenceCountFilterCheckBox.setSelected(false);
		isolationOccurenceCountFilterCheckBox.setOpaque(false);

		final JSlider isolationOccurenceCountFilterSlider = new JSlider(JSlider.HORIZONTAL, 0, 100, 0);
		isolationOccurenceCountFilterSlider.setEnabled(false);
		d = isolationOccurenceCountFilterSlider.getPreferredSize();
		isolationOccurenceCountFilterSlider.setPreferredSize(new Dimension(d.width / 2, d.height));
		isolationOccurenceCountFilterSlider.setOpaque(false);

		final JLabel isolationOccurenceCountFilterValueLabel = new JLabel("0");
		isolationOccurenceCountFilterValueLabel.setEnabled(false);
		isolationOccurenceCountFilterValueLabel.setOpaque(false);

		isolationOccurenceCountFilterCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (isolationOccurenceCountFilterCheckBox.isSelected()) {
					isolationOccurenceCountFilterSlider.setEnabled(true);
					isolationOccurenceCountFilterValueLabel.setEnabled(true);
					minIsolationOccurenceCountThreshold = isolationOccurenceCountFilterSlider.getValue();
				} else {
					isolationOccurenceCountFilterSlider.setEnabled(false);
					isolationOccurenceCountFilterValueLabel.setEnabled(false);
					minIsolationOccurenceCountThreshold = 0;
				}
				preparePatternGraphInfo();
				redrawGraph(true);
			}
		});

		isolationOccurenceCountFilterSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				isolationOccurenceCountFilterValueLabel.setText(isolationOccurenceCountFilterSlider.getValue() + "");
				if (!isolationOccurenceCountFilterSlider.getValueIsAdjusting()) {
					minIsolationOccurenceCountThreshold = isolationOccurenceCountFilterSlider.getValue();
					preparePatternGraphInfo();
					redrawGraph(true);
				}
			}
		});

		c.gridx = 0;
		c.gridy = 3;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(isolationOccurenceCountFilterCheckBox, c);

		c.gridx = 1;
		c.gridy = 3;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(isolationOccurenceCountFilterSlider, c);

		c.gridx = 2;
		c.gridy = 3;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(isolationOccurenceCountFilterValueLabel, c);

		//Conservedness
		conservednessFilterCheckBox = new JCheckBox("Conservedness");
		conservednessFilterCheckBox.setSelected(true);
		conservednessFilterCheckBox.setOpaque(false);

		final JSlider conservednessFilterSlider = new JSlider(JSlider.HORIZONTAL, 0, 100, 0);
		conservednessFilterSlider.setEnabled(true);
		conservednessFilterSlider.setOpaque(false);
		conservednessFilterSlider.setValue(50);
		d = conservednessFilterSlider.getPreferredSize();
		conservednessFilterSlider.setPreferredSize(new Dimension(d.width / 2, d.height));

		final JLabel conservednessFilterValueLabel = new JLabel("50");
		conservednessFilterValueLabel.setEnabled(true);
		conservednessFilterValueLabel.setOpaque(false);

		conservednessFilterCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (conservednessFilterCheckBox.isSelected()) {
					conservednessFilterSlider.setEnabled(true);
					conservednessFilterValueLabel.setEnabled(true);
					minConservednessThreshold = conservednessFilterSlider.getValue();
				} else {
					conservednessFilterSlider.setEnabled(false);
					conservednessFilterValueLabel.setEnabled(false);
					minConservednessThreshold = 50;
				}
				preparePatternGraphInfo();
				redrawGraph(true);
			}
		});

		conservednessFilterSlider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				conservednessFilterValueLabel.setText(conservednessFilterSlider.getValue() + "");
				if (!conservednessFilterSlider.getValueIsAdjusting()) {
					minConservednessThreshold = conservednessFilterSlider.getValue();
					preparePatternGraphInfo();
					redrawGraph(true);
				}
			}
		});

		c.gridx = 0;
		c.gridy = 4;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(conservednessFilterCheckBox, c);

		c.gridx = 1;
		c.gridy = 4;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(conservednessFilterSlider, c);

		c.gridx = 2;
		c.gridy = 4;
		c.gridwidth = 1;
		//c.insets = new Insets(5, 0, 0, 10);
		c.insets = new Insets(13, 0, 0, 15);
		;
		filterPatternPanel.add(conservednessFilterValueLabel, c);

		//alphabetSize
		/*
		 * alphabetSizeFilterCheckBox = new JCheckBox("Alphabet Size");
		 * alphabetSizeFilterCheckBox.setSelected(false);
		 * alphabetSizeFilterCheckBox.setOpaque(false);
		 * 
		 * final JSlider alphabetSizeFilterSlider = new
		 * JSlider(JSlider.HORIZONTAL, 0, 10, 0);
		 * alphabetSizeFilterSlider.setEnabled(false); d =
		 * alphabetSizeFilterSlider.getPreferredSize();
		 * alphabetSizeFilterSlider.setPreferredSize(new Dimension(d.width / 2,
		 * d.height)); alphabetSizeFilterSlider.setOpaque(false);
		 * 
		 * final JLabel alphabetSizeFilterValueLabel = new JLabel("0");
		 * alphabetSizeFilterValueLabel.setEnabled(false);
		 * alphabetSizeFilterValueLabel.setOpaque(false);
		 * 
		 * alphabetSizeFilterCheckBox.addActionListener(new ActionListener() {
		 * public void actionPerformed(ActionEvent arg0) { if
		 * (alphabetSizeFilterCheckBox.isSelected()) {
		 * alphabetSizeFilterSlider.setEnabled(true);
		 * alphabetSizeFilterValueLabel.setEnabled(true); minAlphabetSize =
		 * alphabetSizeFilterSlider.getValue(); } else {
		 * alphabetSizeFilterSlider.setEnabled(false);
		 * alphabetSizeFilterValueLabel.setEnabled(false); minAlphabetSize = 0;
		 * } preparePatternGraphInfo(); redrawGraph(true); } });
		 * 
		 * alphabetSizeFilterSlider.addChangeListener(new ChangeListener() {
		 * public void stateChanged(ChangeEvent arg0) {
		 * alphabetSizeFilterValueLabel
		 * .setText(alphabetSizeFilterSlider.getValue() + ""); if
		 * (!alphabetSizeFilterSlider.getValueIsAdjusting()) { minAlphabetSize =
		 * alphabetSizeFilterSlider.getValue(); preparePatternGraphInfo();
		 * redrawGraph(true); } } });
		 * 
		 * c.gridx = 0; c.gridy = 5; c.gridwidth = 1; //c.insets = new Insets(5,
		 * 0, 0, 10); c.insets = new Insets(13, 0, 0, 15);;
		 * filterPatternPanel.add(alphabetSizeFilterCheckBox, c);
		 * 
		 * c.gridx = 1; c.gridy = 5; c.gridwidth = 1; //c.insets = new Insets(5,
		 * 0, 0, 10); c.insets = new Insets(13, 0, 0, 15);;
		 * filterPatternPanel.add(alphabetSizeFilterSlider, c);
		 * 
		 * c.gridx = 2; c.gridy = 5; c.gridwidth = 1; //c.insets = new Insets(5,
		 * 0, 0, 10); c.insets = new Insets(13, 0, 0, 15);; c.insets = new
		 * Insets(13, 0, 0, 15);;
		 * filterPatternPanel.add(alphabetSizeFilterValueLabel, c);
		 */
	}

	private void preparePatternGraphInfo() {
		Map<TreeSet<String>, Integer> tmpActualNonOverlapAlphabetCountMap = new HashMap<TreeSet<String>, Integer>();
		Map<String, Integer> tmpEncodedActivityCountMap = new HashMap<String, Integer>();

		filterPatternAlphabetSet.clear();
		notUsedSingleActivityInPatternSet.clear();
		if (frequencyFilterCheckBox.isSelected() && (minActivityFrequencyThreshold > 0)) {
			//filter activities according to value of the activity frequency
			for (Entry<String, Integer> entry : encodedActivityCountMap.entrySet()) {
				String activityLabel = entry.getKey();
				Integer activityCount = entry.getValue();
				if (activityCount > minActivityFrequencyThreshold) {
					tmpEncodedActivityCountMap.put(activityLabel, activityCount);
				} else {
					activityToFilterOutSet.add(activityLabel);
				}
			}
			//filter out the corresponding pattern containing the low frequent activities
			for (Entry<TreeSet<String>, Integer> entry : actualNonOverlapAlphabetCountMap.entrySet()) {
				TreeSet<String> alphabet = entry.getKey();
				boolean isEachActFreqSuitable = false;
				for (String activityLabel : alphabet) {
					if (tmpEncodedActivityCountMap.containsKey(activityLabel)) {
						isEachActFreqSuitable = true;
					} else {
						isEachActFreqSuitable = false;
					}
				}
				if (isEachActFreqSuitable) {
					Integer patternCount = entry.getValue();
					tmpActualNonOverlapAlphabetCountMap.put(alphabet, patternCount);
				}
			}
		} else {
			tmpEncodedActivityCountMap.putAll(encodedActivityCountMap);
			tmpActualNonOverlapAlphabetCountMap.putAll(actualNonOverlapAlphabetCountMap);
		}

		//protected JCheckBox frequencyFilterCheckBox, totalOccurenceCountFilterCheckBox,isolationOccurenceCountFilterCheckBox, conservednessFilterCheckBox,
		//Boolean isMeetingFilterConditions = false;
		for (Set<String> alphabet : tmpActualNonOverlapAlphabetCountMap.keySet()) {
			if ((tmpActualNonOverlapAlphabetCountMap.get(alphabet) > minTotalOccurenceCountThreshold)
					&& (patternIsolationNonOverlapAlphabetCountMap.get(alphabet) >= minIsolationOccurenceCountThreshold)
					&& (actualNonOverlapAlphabetConservednessMetricMap.get(alphabet) > minConservednessThreshold)
					&& (alphabet.size() > minAlphabetSize)) {
				filterPatternAlphabetSet.add(alphabet);
			}
		}
		notUsedSingleActivityInPatternSet = ptnAbsFrm.getSingleActivityNotUsedInPatterns(filterPatternAlphabetSet,
				tmpEncodedActivityCountMap);
		absSeqMap = ptnAbsFrm.getAbstractionAlphabetSequenceSetMap(filterPatternAlphabetSet);

		System.out.println("@@@preparePatternGraphInfo :::The count of the absSeqMap is " + absSeqMap.size());
	}

	public void setupUI() {

		setLayout(new BorderLayout());
		setBorder(BorderFactory.createEmptyBorder());
		buildWholeEditPanel();
		wholeEditScrollPane = new JScrollPane(wholeEditPanel);
		//	graphContainedPanel = new JPanel();
		wholePanel = new JPanel();
		wholePanel.setLayout(new BorderLayout());
		wholePanel.setBorder(BorderFactory.createEmptyBorder());
		//	wholePanel.add(graphContainedPanel, BorderLayout.CENTER);
		wholePanel.add(wholeEditScrollPane, BorderLayout.EAST);
		//assemble in the panel
		HeaderBar header = new HeaderBar("Pattern Tree (mined from " + XConceptExtension.instance().extractName(log)
				+ ")");
		header.setHeight(40);
		this.add(header, BorderLayout.NORTH);
		this.add(wholePanel, BorderLayout.CENTER);
	}

	private void setupPopMenu() {
		// Create some menu items for the popup
		JMenuItem menuSavePng = new JMenuItem("Save Pattern Graph As PNG...");
		// Create a popup menu
		popupMenu = new JPopupMenu("");
		popupMenu.add(menuSavePng);
		wholePanel.add(popupMenu);

		// Action and mouse listener support
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);

		menuSavePng.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fileChooser = new JFileChooser("./");
				fileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
				fileChooser.setSelectedFile(new File("PatternGraph"));
				if (fileChooser.showDialog(wholePanel, "Save Pattern Graph As PNG") == JFileChooser.APPROVE_OPTION) {
					try {
						String fileName;
						File file;
						Image graphPanelImage;
						BufferedImage patternGraphImage;
						Graphics2D g2d;
						Dimension dim;
						int graphPanelWidth, graphPanelHeight;
						boolean overwrite = false;
						fileName = fileChooser.getSelectedFile().getAbsolutePath() + ".png";
						if (!overwrite && new File(fileName).exists()) {
							if (JOptionPane.showConfirmDialog(wholePanel, "Warning: this file exists. Overwrite it?",
									"Save file " + fileName, JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE) == JOptionPane.NO_OPTION) {
								return;
							} else {
								overwrite = true;
							}
						}
						file = new File(fileName);
						dim = graphPanel.getPreferredSize();
						graphPanelWidth = dim.width;
						graphPanelHeight = dim.height;
						graphPanelImage = graphPanel.createImage(dim.width, dim.height);
						//	graphPanel.paint(graphPanelImage.getGraphics());

						patternGraphImage = new BufferedImage(graphPanelWidth, graphPanelHeight,
								BufferedImage.TYPE_3BYTE_BGR);
						g2d = patternGraphImage.createGraphics();
						g2d.drawImage(graphPanelImage, 0, 0, wholePanel);
						//	g2d.setColor(Color.white);
						//	g2d.fillRect(0,0, graphPanelWidth, graphPanelHeight);

						ImageIO.write(patternGraphImage, "png", file);

					} catch (IOException e) {
						ErrorDialog.showErrorDialog(wholePanel, e.getMessage());
					}
				}
			}
		});

	}

	public void buildWholeEditPanel() {

		//set up filter pattern panel
		buildFilterPatternPanel();
		//set up the pattern edit panel
		setupEditPanel();
		//set up the desired pattern panel
		setupDesiredPatternPanel();
		wholeEditPanel = new JPanel();

		ScrollableGridLayout wholeEditPanelLayout = new ScrollableGridLayout(wholeEditPanel, 1, 3, 0, 0);

		// Set the rows of the panel to be fixed
		wholeEditPanelLayout.setRowFixed(0, true);
		wholeEditPanelLayout.setRowFixed(1, true);
		wholeEditPanelLayout.setRowFixed(2, true);

		wholeEditPanel.setLayout(wholeEditPanelLayout);

		wholeEditPanelLayout.setPosition(filterPatternPanel, 0, 0);
		wholeEditPanel.add(filterPatternPanel);

		wholeEditPanelLayout.setPosition(editPanel, 0, 1);
		wholeEditPanel.add(editPanel);

		wholeEditPanelLayout.setPosition(desiredPatternPanel, 0, 2);
		wholeEditPanel.add(desiredPatternPanel);

	}

	//rename the node in the pattern tree
	public void renamePatternTreeNodes() {
		//the map between new name of a pattern node and its old one
		//newOldPatternNameMap = new HashMap<String, Set<String>>();		
		Set<PatternTreeNode> nodes = patternTree.getNodes();
		Double alphabetTotalCount;
		Double alphabetStandaloneCount;
		Double alphabetConservednessCount;
		//if there were same subsequence of two different patterns, 
		//modify the 2nd occurred pattern name according to the identifier .eg. "Repair","Repair1","Repair2",etc
		Map<String, Integer> patternNameIdentifierMap = new HashMap<String, Integer>();
		for (PatternTreeNode node : nodes) {
			Set<String> nodeAlphabet = node.getLabelAlphabet();
			//get the total occurrence count of this pattern 
			alphabetTotalCount = node.getAlphabetTotalCount();
			alphabetStandaloneCount = node.getAlphabetStandaloneCount();
			alphabetConservednessCount = node.getAlphabetConservednessCount();

			List<String> decodedActNames = new ArrayList<String>();
			String nodeLabel = node.getLabel();
			//Set<String> nodeLabelAlphabet = node.getLabelAlphabet();
			Set<Set<String>> patternAlphabetSet = new HashSet<Set<String>>();
			patternAlphabetSet.add(nodeAlphabet);
			patternTotalNonOverlapAlphabetCountMap.put(nodeLabel, alphabetTotalCount);
			Object[] activityLabels = FuzzyMapUtil.getActivityLabelsInPattern(node, encodingLength).toArray();
			if (activityLabels.length == 1) {
				//decode the node name in the pattern tree
				String decodeActivityName = charActivityMap.get(activityLabels[0]);
				//the new pattern name is like " event name - event type". eg."abc-start"
				//	newOldPatternNameMap.put(decodeActivityName, nodeLabelAlphabet);
				newOldPatternNameMap.put(decodeActivityName, patternAlphabetSet);
				/*
				 * int delimIdx = decodeActivityName.indexOf("-"); String
				 * singleActivityName = decodeActivityName.substring(0,
				 * delimIdx);
				 */
				node.setNameToEdit(decodeActivityName);
				String newNodeLabel;

				//add node metrics to the label

				newNodeLabel = "<html>" + decodeActivityName + "<br>" + alphabetTotalCount.toString() + "/"
						+ alphabetStandaloneCount.toString() + "/" + alphabetConservednessCount + "</html>";

				node.setLabel(newNodeLabel);
				node.getAttributeMap().put(AttributeMap.SIZE, new Dimension(240, 60));
				node.getAttributeMap().put(AttributeMap.LABELHORIZONTALALIGNMENT, JLabel.CENTER);
				//	newOldPatternNameMap.put(newNodeLabel, nodeLabel);
				decodedActNames.add(decodeActivityName);
			} else {
				//set the default name to the pattern node according to the longest common sequence between its activities
				Object[] decodedActivityLabels = new Object[activityLabels.length];
				int indexOfDelimiter = 0;
				String wholeLabel;
				//get the original event name of each activity in a pattern
				for (int i = 0; i < activityLabels.length; i++) {
					wholeLabel = charActivityMap.get(activityLabels[i]);
					decodedActNames.add(wholeLabel);
					indexOfDelimiter = wholeLabel.indexOf("-");
					//get the event name only
					decodedActivityLabels[i] = wholeLabel.substring(0, indexOfDelimiter);
				}
				//String defaultPatternName = getDefaultPatternName(decodedActivityLabels);
				String defaultPatternName = getAbstractionName(decodedActivityLabels);

				String originalDefaultPatternName = defaultPatternName;
				if (!newOldPatternNameMap.containsKey(defaultPatternName)) {
					//	newOldPatternNameMap.put(defaultPatternName, nodeLabel);
					patternNameIdentifierMap.put(defaultPatternName, 1);
				} else {
					Integer identifier = patternNameIdentifierMap.get(defaultPatternName);
					identifier++;
					defaultPatternName = defaultPatternName + " " + identifier.toString();
					//		newOldPatternNameMap.put(defaultPatternName, nodeLabel);
					patternNameIdentifierMap.put(originalDefaultPatternName, identifier);
				}
				//the defaultPattern Name is like "[abc], [abc] 1,[abc] 2,..."
				newOldPatternNameMap.put(defaultPatternName, patternAlphabetSet);
				node.setNameToEdit(defaultPatternName);
				//	System.out.println("The pattern name of '" + nodeLabel + " ' for Editing is " + defaultPatternName);

				/*
				 * String actNameToShow = ""; int lines =
				 * defaultPatternName.length()/CHAR_COUNT_PER_LINE; for (int i =
				 * 0; i< lines;i++){ int startIdx = i*CHAR_COUNT_PER_LINE;
				 * actNameToShow += defaultPatternName.substring(startIdx,
				 * startIdx+CHAR_COUNT_PER_LINE)+"<br>"; } int numHaveShown =
				 * lines * CHAR_COUNT_PER_LINE;
				 * if(numHaveShown<defaultPatternName.length()){ actNameToShow
				 * +=defaultPatternName.substring(lines*CHAR_COUNT_PER_LINE,
				 * defaultPatternName.length()); }
				 * 
				 * String newNodeLabel = "<html>" + actNameToShow + "<br>" +
				 * alphabetTotalCount.toString() + "/" +
				 * alphabetStandaloneCount.toString() + "/"+
				 * alphabetConservednessCount +"</html>";
				 * node.setLabel(newNodeLabel);
				 */

				defaultPatternName = "<html>" + defaultPatternName + "<br>" + alphabetTotalCount.toString() + "/"
						+ alphabetStandaloneCount.toString() + "/" + alphabetConservednessCount + "</html>";
				node.setLabel(defaultPatternName);
				node.getAttributeMap().put(AttributeMap.SIZE, new Dimension(200, 60));
				node.getAttributeMap().put(AttributeMap.LABELHORIZONTALALIGNMENT, JLabel.CENTER);
			}
			ptnLabelDecodedActivityNameMap.put(nodeLabel, decodedActNames);
		}

		//set the contribution metrics of each edge
		Set<PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode>> edges = patternTree.getEdges();
		for (PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode> edge : edges) {
			PatternTreeNode source = edge.getSource();
			PatternTreeNode target = edge.getTarget();
			Set<Set<String>> oldSourceLabelSet = newOldPatternNameMap.get(source.getNameToEdit());
			Set<Set<String>> oldTargetLabelSet = newOldPatternNameMap.get(target.getNameToEdit());
			Set<String> oldSourceLabel = oldSourceLabelSet.iterator().next();
			Set<String> oldTargetLabel = oldTargetLabelSet.iterator().next();
			Double sourceTotalCount = patternTotalNonOverlapAlphabetCountMap.get(oldSourceLabel.toString());
			Double targetTotalCount = patternTotalNonOverlapAlphabetCountMap.get(oldTargetLabel.toString());
			Double contribution = targetTotalCount / sourceTotalCount;
			String contributionLabel = FuzzyMapUtil.format(contribution);
			setEdgeLabel(edge, contributionLabel);
		}
	}

	private void setEdgeLabel(PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode> edge,
			String edgeLabel) {
		edge.getAttributeMap().put(AttributeMap.LABEL, edgeLabel);
		edge.getAttributeMap().put(AttributeMap.SHOWLABEL, true);
		edge.getAttributeMap().put(AttributeMap.LABELCOLOR, Color.red);
		edge.getAttributeMap().put(AttributeMap.LABELALONGEDGE, true);
	}

	public String getAbstractionName(Object[] decodedActivityObject) {
		String[] delimiterArray = { "~", "!", "@", "#", "%", "^", "&", "*" };
		String abstractionName = "";
		int index = 0;
		String defaultAbstractionName = "[" + (String) decodedActivityObject[0] + "]";
		StringBuilder strBuilder = new StringBuilder();

		List<String> decodedActivitySet = new ArrayList<String>();
		for (Object decodedActivity : decodedActivityObject) {
			decodedActivitySet.add((String) decodedActivity);
			//	System.out.println("In getAbstractionName: " + decodedActivitySet);
		}

		for (String decodedActivity : decodedActivitySet) {
			//			decodedActivity = decodedActivity.replaceAll("start", "").replaceAll("complete", "");
			if (index < decodedActivitySet.size() - 1) {
				strBuilder.append(decodedActivity).append(delimiterArray[index % delimiterArray.length]);
			} else {
				strBuilder.append(decodedActivity);
			}
			index++;
		}
		UkkonenSuffixTree suffixTree = new UkkonenSuffixTree(1, strBuilder.toString());
		suffixTree.findLeftDiverseNodes();
		Set<String> maximalRepeatSet = suffixTree.getMaximalRepeats();
		Set<String> filteredMaximalRepeatSet = new HashSet<String>();
		if (maximalRepeatSet != null) {
			for (String repeat : maximalRepeatSet) {
				if (repeat.length() >= 6) {
					filteredMaximalRepeatSet.add(repeat);
				}
			}
		}
		if (filteredMaximalRepeatSet.size() == 0) {
			abstractionName = defaultAbstractionName;
		} else {
			abstractionName = filteredMaximalRepeatSet.toString();
		}
		return abstractionName;
	}

	/*
	 * get the default name to the pattern node, according to the longest common
	 * sequence between its activities
	 */
	public String getDefaultPatternName(Object[] activityLabels) {
		String defaultPatternName = "";
		String commonSubString = "";
		int maxLengthOfComSubString = 0;
		for (int i = 0; i < activityLabels.length; i++) {
			String current = (String) activityLabels[i];
			for (int j = i + 1; j < activityLabels.length; j++) {
				String another = (String) activityLabels[j];
				commonSubString = FuzzyMapUtil.LongestCommonSubsequence(current, another);
				System.out.println("The LCS of '" + current + "' and '" + another + " is '" + commonSubString + " '");
				if (commonSubString.length() > maxLengthOfComSubString) {
					defaultPatternName = commonSubString;
					maxLengthOfComSubString = commonSubString.length();
				}
			}
		}
		return defaultPatternName;
	}

	public ProMJGraph setGraphListeners() {
		//	GGGraph gGraph = new GGAdapter(graph);
		ProMJGraph paintGraph = graphPanel.getGraph();
		installGraphListeners(paintGraph);
		//	this.graphView.setGraph(gGraph);

		/*
		 * this.revalidate(); this.repaint();
		 */
		return paintGraph;
	}

	protected void installGraphListeners(ProMJGraph graph) {

		// set the action whenever a node in the graph is selected
		GraphSelectionModel model = graph.getSelectionModel();
		model.setSelectionMode(GraphSelectionModel.SINGLE_GRAPH_SELECTION);
		model.addGraphSelectionListener(new GraphSelectionListener() {

			public void valueChanged(GraphSelectionEvent evt) {
				for (Object cell : evt.getCells()) {
					if (evt.isAddedCell(cell)) {
						if (cell instanceof ProMGraphCell) {
							selectedPatternNode = (PatternTreeNode) (((ProMGraphCell) cell).getNode());
							//String newLabel = selectedPatternNode.getLabel();
							String newLabel = selectedPatternNode.getNameToEdit();
							beforeModifiedPatterLabel = newLabel;
							orinalLabelOfCurrentPattern = newLabel;
							int patternUsageMode = setInformationOfSelectedPattern(newLabel);
							switch (patternUsageMode) {
								case NOT_USE_YET :
									notToUseRadioButton.setSelected(true);
									break;
								case SINGLE_PATTERN_MODE :
									desireNodeRadioButton.setSelected(true);
									break;
								case ABSTRACTION_MODE :
									desireSubGraphRadioButton.setSelected(true);
									break;
								default :
									notToUseRadioButton.setSelected(true);
									break;
							}
							//	editPanel.revalidate();
							//  editPanel.repaint();
						}
					}
				}
				editPanel.revalidate();
				editPanel.repaint();
			}
		});
	}

	//set the detail information of the pattern user selected
	public int setInformationOfSelectedPattern(String nameToEdit) {

		Set<Set<String>> oldPatternNames = new HashSet<Set<String>>();
		Set<String> oldLabel = new HashSet<String>();
		if (newOldPatternNameMap.containsKey(nameToEdit)) {
			oldPatternNames = newOldPatternNameMap.get(nameToEdit);
			System.out.println("!!!!setInformationOf:" + nameToEdit + "|| oldPatternNames:" + oldPatternNames);
			oldLabel = oldPatternNames.iterator().next();
		}

		List<String> decodedActivityNames = ptnLabelDecodedActivityNameMap.get(oldLabel.toString());
		activityListModel.removeAllElements();
		//treat all the pattern in the same way
		nameField.setEnabled(true);
		nameField.setText(nameToEdit);
		for (int i = 0; i < decodedActivityNames.size(); i++) {
			activityListModel.addElement(decodedActivityNames.get(i));
		}
		//set the state of radio button group
		int patternUsageMode = judgeUsageModeOfPattern(oldLabel);
		return patternUsageMode;

		//   editPanel.revalidate();
		//editPanel.repaint();

	}

	private int judgeUsageModeOfPattern(Set<String> patternOldLabel) {
		int mode = -1;
		if (selectedPatternAlphabetNewLabel.containsKey(patternOldLabel)) {
			String patternName = selectedPatternAlphabetNewLabel.get(patternOldLabel);
			Set<Set<String>> allAlphabet = selectedPatternNameAlphabetMap.get(patternName);
			int numOfAllAlphbet = allAlphabet.size();
			if (numOfAllAlphbet > 1) {
				mode = ABSTRACTION_MODE;
			}
			if (numOfAllAlphbet == 1) {
				mode = SINGLE_PATTERN_MODE;
			}
		} else {
			mode = NOT_USE_YET;
		}
		return mode;
	}

	/*
	 * After redrawing the graph ,the attribute values of each components in the
	 * edit panel and desired pattern panel need to be empty.
	 */

	private void resetGUIAttribute() {
		nameField.setText("");
		activityListModel.clear();
		notToUseRadioButton.setSelected(true);
		selectAllRadioButton.setSelected(false);
		patternListModel.clear();
		editPanel.revalidate();
		editPanel.repaint();
		desiredPatternPanel.revalidate();
		desiredPatternPanel.repaint();

	}

	public void setupEditPanel() {
		editPanel = new JPanel();
		editPanel.setBorder(BorderFactory.createEtchedBorder());
		/*
		 * editPanel.setPreferredSize(new Dimension(300, 450));
		 * editPanel.setMaximumSize(new Dimension(300, 450));
		 * editPanel.setMinimumSize(new Dimension(300, 450));
		 */
		editPanel.setBackground(background);
		editPanel.setVisible(true);

		GridBagLayout editPatternGBLayout = new GridBagLayout();
		editPanel.setLayout(editPatternGBLayout);

		final GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		JLabel title = new JLabel("Edit Pattern");
		title.setFont(title.getFont().deriveFont(15f));
		title.setHorizontalAlignment(JLabel.CENTER);
		title.setHorizontalTextPosition(JLabel.CENTER);
		title.setAlignmentX(JLabel.CENTER_ALIGNMENT);
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 2;
		c.gridheight = 1;
		c.insets = new Insets(16, 0, 0, 15);

		editPanel.add(title, c);

		//pattern name

		nameLabel = new JLabel("Name:");
		nameLabel.setMaximumSize(new Dimension(55, 25));
		nameLabel.setPreferredSize(new Dimension(55, 25));
		nameField = new JTextField("");
		//nameField.getDocument().addDocumentListener(new NameDocumentListener());
		nameField.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				// live update of node property changes
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						String modifiedPatternName = nameField.getText();
						//When there is no duplicate pattern and the  name of the current pattern has been changed
						//the current pattern will be deleted from the desired pattern list
						if (!isThereDuplicatePattern && patternListModel.contains(beforeModifiedPatterLabel)) {
							patternListModel.removeElement(beforeModifiedPatterLabel);
							if (desireNodeRadioButton.isSelected() || desireSubGraphRadioButton.isSelected()) {
								patternListModel.addElement(modifiedPatternName);
							}
						}
						updateGraphNodeLabel();
						//notToUseRadioButton.setSelected(true);
						beforeModifiedPatterLabel = modifiedPatternName;
					}
				});
			}
		});
		nameField.setFont(nameField.getFont().deriveFont(11f));
		nameField.setBackground(new Color(180, 180, 180));
		nameField.setForeground(new Color(10, 10, 10));
		nameField.setSize(80, 20);
		nameField.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));

		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 1;
		c.insets = new Insets(16, 0, 0, 15);
		editPanel.add(nameLabel, c);

		c.gridx = 1;
		c.gridy = 1;
		c.gridwidth = 1;
		c.insets = new Insets(16, 0, 0, 15);
		editPanel.add(nameField, c);

		//activities in the pattern
		activityLabel = new JLabel("Activities:");
		activityLabel.setMaximumSize(new Dimension(55, 25));
		activityLabel.setPreferredSize(new Dimension(55, 25));
		activityLabel.setOpaque(false);
		//	activityLabel.setFont(nameLabel.getFont().deriveFont(11f));
		activityListModel = new DefaultListModel();
		activityList = new JList(activityListModel);
		//	activityList.setSelectionInterval(0, activityNameString.length - 1);
		JScrollPane activityListScrollPanel = new JScrollPane();
		activityListScrollPanel.setPreferredSize(new Dimension(100, 150));
		activityListScrollPanel.setViewportView(activityList);

		c.gridx = 0;
		c.gridy = 2;
		c.gridwidth = 1;
		c.gridheight = 5;
		c.insets = new Insets(16, 0, 0, 15);
		editPanel.add(activityLabel, c);

		c.gridx = 1;
		c.gridy = 2;
		c.gridwidth = 1;
		c.gridheight = 5;
		c.insets = new Insets(16, 0, 0, 15);
		editPanel.add(activityListScrollPanel, c);

		//usage mode	

		JLabel usingModeLabel = new JLabel("Usage Mode");
		usingModeLabel.setOpaque(false);
		c.gridx = 0;
		c.gridy = 7;
		c.gridwidth = 1;
		c.gridheight = 3;
		c.insets = new Insets(16, 0, 0, 15);
		editPanel.add(usingModeLabel, c);

		notToUseRadioButton = new JRadioButton("Not to be used");
		notToUseRadioButton.setUI(new SlickerRadioButtonUI());
		//	notToUseRadioButton.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 2));
		notToUseRadioButton.setOpaque(false);
		notToUseRadioButton.setAlignmentX(JRadioButton.LEFT_ALIGNMENT);
		notToUseRadioButton.setHorizontalAlignment(JRadioButton.LEFT);
		notToUseRadioButton.setSelected(true);
		notToUseRadioButton.setToolTipText("<html> Don't use the selected pattern to preprocess the log.</html>");
		notToUseRadioButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Set<Set<String>> ptnNameAlphabet = new HashSet<Set<String>>();
				if (!isThereDuplicatePattern) {
					String patternName = nameField.getText();
					Set<String> selectedNodeName = selectedPatternNode.getLabelAlphabet();
					//	ptnNameAlphabet = newOldPatternNameMap.get(patternName);

					if (notToUseRadioButton.isSelected()) {
						selectedPatternNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.WHITE);
						//if the selected node has been selected to transform the log later 
						if (selectedPatternNameAlphabetMap.containsKey(patternName)) {
							ptnNameAlphabet = selectedPatternNameAlphabetMap.get(patternName);
							if (ptnNameAlphabet.size() > 1) {
								//The selected node was used in the "Abstraction Mode" before
								//change the color of the nodes in the sub tree
								setColorOfNodesInSubTree(selectedPatternNode, false);
							}
							patternListModel.removeElement(nameField.getText());
							//remove the corresponding data because the pattern with this name will not be used
							selectedPatternNameAlphabetMap.remove(patternName);
							//oldLabelsOfSelectedPatterns.remove(selectedPatternNode.getLabelAlphabet());
							for (Set<String> offspringPtnName : ptnNameAlphabet) {
								oldLabelsOfSelectedPatterns.remove(offspringPtnName);
								selectedPatternAlphabetNewLabel.remove(offspringPtnName);
							}
							//newOldPatternNameMap.remove(patternName);
							parentOffspringNodesMap.remove(selectedPatternNode);
						} else {
							//the node was not be used a member of abstraction mode or
							//the node has not been used before
							if (selectedPatternAlphabetNewLabel.containsKey(selectedNodeName)) {
								String parentNodeName = selectedPatternAlphabetNewLabel.get(selectedNodeName);
								PatternTreeNode parentNode = findOriginalParentNode(selectedPatternNode);
								selectedPatternNameAlphabetMap.get(parentNodeName).remove(selectedNodeName);
								oldLabelsOfSelectedPatterns.remove(selectedNodeName);
								selectedPatternAlphabetNewLabel.remove(selectedNodeName);
								parentOffspringNodesMap.get(parentNode).remove(selectedPatternNode);
							}
						}

					}
					patternTree.signalViews();
				} else {
					JOptionPane.showMessageDialog(editPanel, "Please give another name to the current pattern!");
					notToUseRadioButton.setSelected(false);
				}
			}
		});

		c.gridx = 1;
		c.gridy = 8;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(10, 0, 0, 15);
		editPanel.add(notToUseRadioButton, c);

		desireNodeRadioButton = new JRadioButton("Single Pattern Mode");
		desireNodeRadioButton.setUI(new SlickerRadioButtonUI());
		//edgesBestRadioButton.setFont(this.smallFont);
		//desireNodeRadioButton.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 2));
		desireNodeRadioButton.setOpaque(false);
		//	desireNodeRadioButton.setForeground(COLOR_FG);
		desireNodeRadioButton.setAlignmentX(JRadioButton.LEFT_ALIGNMENT);
		desireNodeRadioButton.setHorizontalAlignment(JRadioButton.LEFT);
		desireNodeRadioButton.setSelected(false);
		desireNodeRadioButton.setToolTipText("<html> Only use the selected pattern to preprocess the log.</html>");

		desireNodeRadioButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Set<PatternTreeNode> offSpringNodes = new HashSet<PatternTreeNode>();
				Set<Set<String>> ptnNameAlphabet = new HashSet<Set<String>>();
				Set<String> selectedPtnAlphabet = selectedPatternNode.getLabelAlphabet();
				int nodeUsageMode = judgeUsageModeOfPattern(selectedPtnAlphabet);
				System.out.println("@@@ Node Radio Button is selected ! And the Selected is used in " + nodeUsageMode
						+ "th mode!!!");
				if (nodeUsageMode != SINGLE_PATTERN_MODE) {
					//if the selected node has already been used in a single pattern mode,nothing will be done
					offSpringNodes.add(selectedPatternNode);
					if (!isThereDuplicatePattern) {
						String patternName = nameField.getText();
						if (desireNodeRadioButton.isSelected()) {
							//add the current pattern name into the patters list
							if (patternListModel.contains(patternName)) {
								setColorOfNodesInSubTree(selectedPatternNode, false);
							} else {
								patternListModel.addElement(patternName);
							}

							//this pattern was used in an abstraction mode before

							ptnNameAlphabet.add(selectedPtnAlphabet);
							if (oldLabelsOfSelectedPatterns.contains(selectedPtnAlphabet)) {
								String message = new String(
										"<html> Are you sure to change the usage mode of the Pattern '"
												+ selectedPatternNode.getNameToEdit() + "'"
												+ " as the Single Pattern mode?");
								//there exists conflict pattern nodes
								int chooseResult = JOptionPane.showConfirmDialog(wholePanel, message,
										"Conflict Patterns Confirm Dialog", JOptionPane.YES_NO_OPTION);
								if (chooseResult == JOptionPane.YES_OPTION) {
									setParentOffspringNodeMap(selectedPatternNode, offSpringNodes, ptnNameAlphabet,
											offSpringNodes, ptnNameAlphabet, patternName, true);
									selectedPatternNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.CYAN);
								} else {
									desireSubGraphRadioButton.setSelected(true);
								}
							} else {
								selectedPatternNameAlphabetMap.put(patternName, ptnNameAlphabet);
								selectedPatternAlphabetNewLabel
										.put(selectedPatternNode.getLabelAlphabet(), patternName);
								oldLabelsOfSelectedPatterns.add(selectedPatternNode.getLabelAlphabet());
								//newOldPatternNameMap.put(patternName, ptnNameAlphabet);						
								parentOffspringNodesMap.put(selectedPatternNode, offSpringNodes);
								selectedPatternNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.CYAN);
							}

						}
						patternTree.signalViews();
					} else {
						JOptionPane.showMessageDialog(editPanel, "Please give another name to the current pattern!");
						desireNodeRadioButton.setSelected(false);
					}
				}
			}
		});

		c.gridx = 1;
		c.gridy = 9;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(10, 0, 0, 15);
		editPanel.add(desireNodeRadioButton, c);

		//select all the offspring patterns of this pattern as one pattern,
		//i.e. use the patterns in the subtree whose root is this pattern to transform the log 
		desireSubGraphRadioButton = new JRadioButton("Sub-graph Mode");
		desireSubGraphRadioButton.setUI(new SlickerRadioButtonUI());
		//edgesBestRadioButton.setFont(this.smallFont);
		//desireSubGraphRadioButton.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 2));
		desireSubGraphRadioButton.setOpaque(false);
		//	desireNodeRadioButton.setForeground(COLOR_FG);
		desireSubGraphRadioButton.setAlignmentX(JRadioButton.LEFT_ALIGNMENT);
		desireSubGraphRadioButton.setHorizontalAlignment(JRadioButton.LEFT);
		desireSubGraphRadioButton.setSelected(false);
		desireSubGraphRadioButton.setToolTipText("<html> Use all the patterns in the subtree whose <br>"
				+ "root is the selected pattern to preprocess the log.</html>");

		desireSubGraphRadioButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int nodeUsageMode = judgeUsageModeOfPattern(selectedPatternNode.getLabelAlphabet());
				System.out.println("@@@ Node Radio Button is selected ! And the Selected is used in " + nodeUsageMode
						+ "th mode!!!");
				if (nodeUsageMode != ABSTRACTION_MODE) {
					//if the selected node has already been used in a single pattern mode,nothing will be done
					if (!isThereDuplicatePattern) {
						String patternName = nameField.getText();
						if (desireSubGraphRadioButton.isSelected()) {
							//add the current pattern name into the patters list
							if (!patternListModel.contains(patternName)) {
								patternListModel.addElement(patternName);
							}
							Set<PatternTreeNode> offSpringNodes = getOffspringNodes(selectedPatternNode);
							Set<Set<String>> offSpringLabelAlphabetSets = getOffspringNodesAlphbet(offSpringNodes);
							Set<Set<String>> confictPatternsAlphabets;
							Set<PatternTreeNode> conflictNodes = getConflictNodes(selectedPatternNode, offSpringNodes);
							confictPatternsAlphabets = getConflictNodesAlphabet(conflictNodes);
							if (confictPatternsAlphabets.size() == 0) {
								setParentOffspringNodeMap(selectedPatternNode, offSpringNodes,
										offSpringLabelAlphabetSets, conflictNodes, confictPatternsAlphabets,
										patternName, false);
							} else if (confictPatternsAlphabets.size() > 0) {
								/*
								 * Set<String> theConflictAlphabetLabel =
								 * FuzzyMapUtil
								 * .findLongestLabel(confictPatternsAlphabets);
								 * String theConflictAlphabet= new String("");
								 * if
								 * (selectedPatternAlphabetNewLabel.containsKey
								 * (theConflictAlphabetLabel)){
								 * theConflictAlphabet =
								 * selectedPatternAlphabetNewLabel
								 * .get(theConflictAlphabetLabel);
								 * System.out.println
								 * ("The pattern name of the alphabet " +
								 * theConflictAlphabetLabel + ": " +
								 * theConflictAlphabet); }
								 */
								String conflictNodesLabel = new String("");
								for (PatternTreeNode cfltNode : conflictNodes) {
									conflictNodesLabel += "     " + cfltNode.getNameToEdit() + "," + "<br>";
								}

								conflictNodesLabel = conflictNodesLabel.substring(0, conflictNodesLabel.length());
								String message = new String("<html> Do you want to substitute the following patterns :"
										+ "<br>" + conflictNodesLabel + "      to the pattern " + "'" + patternName
										+ "' ?");
								//there exists conflict pattern nodes
								int chooseResult = JOptionPane.showConfirmDialog(wholePanel, message,
										"Conflict Pattern Confirm Dialog", JOptionPane.YES_NO_OPTION);
								if (chooseResult == JOptionPane.YES_OPTION) {
									setParentOffspringNodeMap(selectedPatternNode, offSpringNodes,
											offSpringLabelAlphabetSets, conflictNodes, confictPatternsAlphabets,
											patternName, true);
								} else {
									setParentOffspringNodeMap(selectedPatternNode, offSpringNodes,
											offSpringLabelAlphabetSets, conflictNodes, confictPatternsAlphabets,
											patternName, false);
								}
							}

							selectedPatternNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.GREEN);
							setColorOfNodesInSubTree(selectedPatternNode, true);

						}
						patternTree.signalViews();
					} else {
						JOptionPane.showMessageDialog(editPanel, "Please give another name to the current pattern!");
						desireSubGraphRadioButton.setSelected(false);
					}
				}
			}
		});

		c.gridx = 1;
		c.gridy = 10;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(10, 0, 0, 15);
		;
		editPanel.add(desireSubGraphRadioButton, c);

		ButtonGroup radioEdgesGroup = new ButtonGroup();
		radioEdgesGroup.add(notToUseRadioButton);
		radioEdgesGroup.add(desireNodeRadioButton);
		radioEdgesGroup.add(desireSubGraphRadioButton);
	}

	/*
	 * check whether each offspring node of the selected node has been used
	 * before
	 */
	private Set<Set<String>> getConflictNodesAlphabet(Set<PatternTreeNode> conflictNodes) {
		Set<Set<String>> confictPatternsAlphabet = new HashSet<Set<String>>();
		//Set<Set<String>> offSpringLabelAlphabetSets = getOffspringNodesAlphbet(selectedNode);
		for (PatternTreeNode node : conflictNodes) {
			confictPatternsAlphabet.add(node.getLabelAlphabet());
		}
		return confictPatternsAlphabet;
	}

	private Set<PatternTreeNode> getConflictNodes(PatternTreeNode selectedNode, Set<PatternTreeNode> offSpringNodes) {
		Set<PatternTreeNode> conflictNodes = new HashSet<PatternTreeNode>();
		//	Set<PatternTreeNode> offSpringNodes = getOffspringNodes(selectedNode);
		offSpringNodes.add(selectedNode);
		for (PatternTreeNode node : offSpringNodes) {
			Set<String> nodeAlphabet = node.getLabelAlphabet();
			if (oldLabelsOfSelectedPatterns.contains(nodeAlphabet)) {
				conflictNodes.add(node);
			}
		}
		return conflictNodes;
	}

	/*
	 * get the offspring nodes of the selected node
	 */
	private Set<PatternTreeNode> getOffspringNodes(PatternTreeNode selectedNode) {
		Set<PatternTreeNode> offSpringNodes = new HashSet<PatternTreeNode>();
		//find all the offspring pattern nodes
		Set<PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode>> inEdges = ((PatternTreeImpl) patternTree)
				.getInEdges(selectedNode);

		Set<PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode>> tmpInEdges = new HashSet<PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode>>();
		tmpInEdges.addAll(inEdges);
		while (!tmpInEdges.isEmpty()) {
			tmpInEdges.clear();
			for (PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode> inEdge : inEdges) {
				PatternTreeNode offspringNode = inEdge.getSource();
				if (offspringNode != null) {
					offSpringNodes.add(offspringNode);
					Set<PatternTreeEdge<? extends PatternTreeNode, ? extends PatternTreeNode>> offSprInEdges;
					offSprInEdges = ((PatternTreeImpl) patternTree).getInEdges(offspringNode);
					if (!offSprInEdges.isEmpty()) {
						tmpInEdges.addAll(offSprInEdges);
					}
				}
			}
			inEdges.clear();
			inEdges.addAll(tmpInEdges);
		}
		return offSpringNodes;
	}

	/*
	 * If the pattern is used in the abstraction mode, this method will get all
	 * the alphabet in the subtree.
	 */
	private Set<Set<String>> getOffspringNodesAlphbet(Set<PatternTreeNode> offSpringNodes) {
		Set<Set<String>> offSpringLabelAlphabetSets = new HashSet<Set<String>>();
		//Set<PatternTreeNode> offSpringNodes = getOffspringNodes(selectedNode);
		for (PatternTreeNode node : offSpringNodes) {
			offSpringLabelAlphabetSets.add(node.getLabelAlphabet());
		}
		return offSpringLabelAlphabetSets;
	}

	/*
	 * Set the map between the parent node and its offspring nodes
	 */
	private void setParentOffspringNodeMap(PatternTreeNode selectedNode, Set<PatternTreeNode> offSpringNodes,
			Set<Set<String>> offSpringLabelAlphabetSets, Set<PatternTreeNode> conflictNodes,
			Set<Set<String>> conflictPatternAlphabet, String newPatternName, boolean isSubstiuteOriginalPattern) {

		//get selected node's alphabet
		Set<String> selectedNodeLabelAlphabet = selectedNode.getLabelAlphabet();
		offSpringLabelAlphabetSets.add(selectedNodeLabelAlphabet);
		if (conflictPatternAlphabet.size() > 0) {
			if (isSubstiuteOriginalPattern) {

				//make the conflict pattern alphabet correspond to its new pattern name
				for (Set<String> conflictPattern : conflictPatternAlphabet) {
					String originalPatternName = selectedPatternAlphabetNewLabel.get(conflictPattern);
					selectedPatternNameAlphabetMap.get(originalPatternName).remove(conflictPattern);
					if (selectedPatternAlphabetNewLabel.containsKey(conflictPattern)) {
						selectedPatternAlphabetNewLabel.remove(conflictPattern);
						selectedPatternAlphabetNewLabel.put(conflictPattern, newPatternName);
					}
				}
				PatternTreeNode firstConflictNode = conflictNodes.iterator().next();
				if ((conflictPatternAlphabet.size() == 1) && parentOffspringNodesMap.containsKey(firstConflictNode)) {
					//if the usage mode of the selected node was changed from the abstraction node to single pattern node 
					//we should delete the whole map between the parent and its offsprings 
					Set<PatternTreeNode> offspringnodes = parentOffspringNodesMap.get(firstConflictNode);
					//	selectedPatternAlphabetNewLabel.remove(firstConflictNode.getLabelAlphabet());
					for (PatternTreeNode offspring : offspringnodes) {
						oldLabelsOfSelectedPatterns.remove(offspring.getLabelAlphabet());
						selectedPatternAlphabetNewLabel.remove(offspring.getLabelAlphabet());
					}
					selectedPatternNameAlphabetMap.remove(firstConflictNode.getLabelAlphabet());
					parentOffspringNodesMap.remove(firstConflictNode);
				} else {
					//make the conflict nodes not the offsprings of its original parent node anymore
					for (PatternTreeNode conflictNode : conflictNodes) {
						PatternTreeNode originalParentNode = findOriginalParentNode(conflictNode);
						parentOffspringNodesMap.get(originalParentNode).remove(conflictNode);
					}
				}
			} else {
				//remove all the conflictNodes from the offspring nodes set of the current selected pattern node
				offSpringNodes.removeAll(conflictNodes);
				offSpringLabelAlphabetSets.removeAll(conflictPatternAlphabet);
			}
		}

		parentOffspringNodesMap.put(selectedNode, offSpringNodes);
		//	oldLabelsOfSelectedPatterns.add(selectedNodeLabelAlphabet);
		oldLabelsOfSelectedPatterns.addAll(offSpringLabelAlphabetSets);
		selectedPatternNameAlphabetMap.put(newPatternName, offSpringLabelAlphabetSets);
		for (Set<String> selectedPatternAlphabet : offSpringLabelAlphabetSets) {
			selectedPatternAlphabetNewLabel.put(selectedPatternAlphabet, newPatternName);
		}
	}

	/*
	 * find the original parent node
	 */
	private PatternTreeNode findOriginalParentNode(PatternTreeNode offspringNode) {
		PatternTreeNode parentNode = null;
		Set<Entry<PatternTreeNode, Set<PatternTreeNode>>> entryset = parentOffspringNodesMap.entrySet();
		for (Entry<PatternTreeNode, Set<PatternTreeNode>> entry : entryset) {
			if (entry.getValue().contains(offspringNode)) {
				parentNode = entry.getKey();
				break;
			}
		}
		return parentNode;
	}

	/*	 *
	 * According the status whether this node is selected or not, set the color
	 * of its offsprings
	 */
	private void setColorOfNodesInSubTree(PatternTreeNode selectedNode, boolean isDesiredPattern) {
		//find all the offspring pattern nodes
		Set<PatternTreeNode> offspringNodes = parentOffspringNodesMap.get(selectedNode);
		Color backgroundColor;
		if (isDesiredPattern) {
			backgroundColor = Color.GREEN;
		} else {
			backgroundColor = Color.WHITE;
		}
		if (!offspringNodes.isEmpty()) {
			for (PatternTreeNode offspringNode : offspringNodes) {
				offspringNode.getAttributeMap().put(AttributeMap.FILLCOLOR, backgroundColor);
			}
		}
	}

	public void updateGraphNodeLabel() {

		//adjust the color of the selected node according to its usage mode
		/*
		 * if(desireNodeRadioButton.isSelected()){
		 * selectedPatternNode.getAttributeMap
		 * ().put(AttributeMap.FILLCOLOR,Color.WHITE); }
		 * if(desireSubGraphRadioButton.isSelected()){
		 * selectedPatternNode.getAttributeMap
		 * ().put(AttributeMap.FILLCOLOR,Color.WHITE);
		 * setColorOfNodesInSubTree(selectedPatternNode,false); }
		 */

		//adjust the pattern node label in the graph	
		String oldNodeLabel = selectedPatternNode.getLabel();
		String oldNameToEdit = selectedPatternNode.getNameToEdit();
		String afterModifiedlabel = nameField.getText();
		Set<Set<String>> oldPatternLabelSet;
		String patternLabelToRemove;
		if (afterModifiedlabel.length() > 0) {
			selectedPatternNode.setNameToEdit(afterModifiedlabel);
			String newLabel = oldNodeLabel.replace(oldNameToEdit, afterModifiedlabel);
			selectedPatternNode.setLabel(newLabel);
			selectedPatternNode.getAttributeMap().put(AttributeMap.LABEL, newLabel);
			patternTree.signalViews();

			//adjust the maps accordingly for transform the log later		
			if (!newOldPatternNameMap.containsKey(afterModifiedlabel)) {
				//if (!selectedPatternNameAlphabetMap.containsKey(afterModifiedlabel)) {
				if (isThereDuplicatePattern || (beforeModifiedPatterLabel.length() == 0)) {
					/*
					 * if there is duplicate patterns before this modification,
					 * or the user has delete all the characters in the pattern
					 * label it is necessary to get the pattern alphabet
					 * according to the original label of the pattern
					 */
					patternLabelToRemove = orinalLabelOfCurrentPattern;
					orinalLabelOfCurrentPattern = afterModifiedlabel;
				} else {
					patternLabelToRemove = beforeModifiedPatterLabel;
				}
				oldPatternLabelSet = newOldPatternNameMap.get(patternLabelToRemove);
				newOldPatternNameMap.remove(patternLabelToRemove);
				//change the current used patterns
				//	oldLabelsOfSelectedPatterns.remove(oldPatternLabelSet);
				if (selectedPatternNameAlphabetMap.containsKey(patternLabelToRemove)) {
					Set<Set<String>> beforeModifiedPatternAlphabetSet = selectedPatternNameAlphabetMap
							.get(patternLabelToRemove);
					//oldLabelsOfSelectedPatterns.removeAll(beforeModifiedPatternAlphabetSet);
					selectedPatternNameAlphabetMap.remove(patternLabelToRemove);
					selectedPatternNameAlphabetMap.put(afterModifiedlabel, beforeModifiedPatternAlphabetSet);
					for (Set<String> selectedPatternAlphabet : beforeModifiedPatternAlphabetSet) {
						//selectedPatternAlphabetNewLabel.remove(selectedPatternAlphabet);
						selectedPatternAlphabetNewLabel.put(selectedPatternAlphabet, afterModifiedlabel);
					}
				}
				newOldPatternNameMap.put(afterModifiedlabel, oldPatternLabelSet);
				//	selectedPatternNameAlphabetMap.put(afterModifiedlabel, oldPatternLabelSet);
				isThereDuplicatePattern = false;
			} else {
				if (!beforeModifiedPatterLabel.equals(afterModifiedlabel)) {
					isThereDuplicatePattern = true;
					orinalLabelOfCurrentPattern = beforeModifiedPatterLabel;
					JOptionPane
							.showMessageDialog(this,
									"There is already a pattern with this name,please give another name to the current pattern!");
					nameField.setFocusable(true);
				}
			}
		}

		//adjust the color of the selected node according to its usage mode
		/*
		 * if(desireNodeRadioButton.isSelected()){
		 * selectedPatternNode.getAttributeMap
		 * ().put(AttributeMap.FILLCOLOR,Color.WHITE); }
		 * if(desireSubGraphRadioButton.isSelected()){
		 * selectedPatternNode.getAttributeMap
		 * ().put(AttributeMap.FILLCOLOR,Color.WHITE);
		 * setColorOfNodesInSubTree(selectedPatternNode,false); }
		 */
	}

	public void setupDesiredPatternPanel() {
		desiredPatternPanel = new JPanel();
		desiredPatternPanel.setBorder(BorderFactory.createEtchedBorder());
		desiredPatternPanel.setBackground(background);
		desiredPatternPanel.setVisible(true);

		GridBagLayout desiredPatternGBLayout = new GridBagLayout();
		desiredPatternPanel.setLayout(desiredPatternGBLayout);

		final GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		patternLabel = new JLabel("Patterns To Use");
		patternLabel.setFont(patternLabel.getFont().deriveFont(15f));
		patternLabel.setHorizontalAlignment(JLabel.CENTER);
		patternLabel.setHorizontalTextPosition(JLabel.CENTER);
		patternLabel.setAlignmentX(JLabel.CENTER_ALIGNMENT);

		patternListModel = new DefaultListModel();
		patternList = new JList(patternListModel);
		patternList.setSelectionInterval(0, 0);
		patternList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		//according to the pattern the user selected to set the pattern value in the Edit Panel
		MouseListener mouseListener = new MouseAdapter() {
			public void mouseClicked(MouseEvent mouseEvent) {
				JList theList = (JList) mouseEvent.getSource();
				//if (mouseEvent.getClickCount() == 1) {
				int index = theList.locationToIndex(mouseEvent.getPoint());
				if (index >= 0) {
					Object o = theList.getModel().getElementAt(index);
					String selectedPatterLabel = o.toString();
					beforeModifiedPatterLabel = selectedPatterLabel;
					//	System.out.println("From the List the selected pattern is : " + o.toString());
					//nameField.setText(o.toString());
					int patternUsageMode = setInformationOfSelectedPattern(selectedPatterLabel);
					switch (patternUsageMode) {
						case NOT_USE_YET :
							notToUseRadioButton.setSelected(true);
							break;
						case SINGLE_PATTERN_MODE :
							desireNodeRadioButton.setSelected(true);
							break;
						case ABSTRACTION_MODE :
							desireSubGraphRadioButton.setSelected(true);
							break;
						default :
							notToUseRadioButton.setSelected(true);
							break;
					}
					findTheCorrespondingPatterNode(selectedPatterLabel);
					editPanel.revalidate();
					editPanel.repaint();
				}
			}
			//}
		};
		patternList.addMouseListener(mouseListener);
		JScrollPane patternListScrollPanel = new JScrollPane();
		patternListScrollPanel.setPreferredSize(new Dimension(80, 120));
		patternListScrollPanel.setViewportView(patternList);
		JPanel patternPanel = new JPanel();
		patternPanel.add(patternListScrollPanel);
		patternPanel.setOpaque(false);

		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 2;
		c.insets = new Insets(16, 0, 0, 15);
		desiredPatternPanel.add(patternLabel, c);

		c.gridx = 0;
		c.gridy = 2;
		c.gridwidth = 1;
		c.gridheight = 5;
		c.insets = new Insets(16, 0, 0, 15);
		desiredPatternPanel.add(patternListScrollPanel, c);

		//select all patterns
		selectAllRadioButton = new JRadioButton("Select All Patterns");
		selectAllRadioButton.setUI(new SlickerRadioButtonUI());
		selectAllRadioButton.setOpaque(false);
		selectAllRadioButton.setAlignmentX(JRadioButton.LEFT_ALIGNMENT);
		selectAllRadioButton.setHorizontalAlignment(JRadioButton.LEFT);
		selectAllRadioButton.setSelected(false);
		selectAllRadioButton.setToolTipText("<html> Select all patterns to preprocess the log.</html>");
		selectAllRadioButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (selectAllRadioButton.isSelected()) {
					//make every component in the EditPanel become disable
					nameField.setText("");
					nameField.setEditable(false);
					activityList.removeAll();
					activityList.setEnabled(false);
					notToUseRadioButton.setEnabled(false);
					desireNodeRadioButton.setEnabled(false);
					;
					desireSubGraphRadioButton.setEnabled(false);
					//clear the current selection of patterns
					selectedPatternNameSequenceMap.clear();
					oldLabelsOfSelectedPatterns.clear();
					selectedPatternAlphabetNewLabel.clear();
					parentOffspringNodesMap.clear();
					patternListModel.removeAllElements();
					Set<String> usedSeqs = new HashSet<String>();
					//all the maximalElements will be used in an abstraction mode		
					//System.out.println("###The total amount of  maximalElements is " + absSeqMap.size());
					setOldNewPatternNameMap();
					for (Set<String> maximalElement : absSeqMap.keySet()) {
						//if (maximalElement.size() > 1) {
						//System.out.println("###The current maximalElement is " + maximalElement);
						String newPtnName = "";
						if (oldNewPatternNameMap.containsKey(maximalElement)) {
							newPtnName = oldNewPatternNameMap.get(maximalElement);
						}

						//set the color of nodes in the maximalElement subgraph
						PatternTreeNode abstractionNode = getAbstractionNode(maximalElement);
						Set<PatternTreeNode> offSpringNodes = getOffspringNodes(abstractionNode);
						parentOffspringNodesMap.put(abstractionNode, offSpringNodes);
						abstractionNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.GREEN);
						setColorOfNodesInSubTree(abstractionNode, true);
						//set the value of corresponding data variants to keep the information to use these maximal Element
						//The sequence got from the absSeqMap is only the abstraction's sequence
						Set<String> allAbstractionSequence = absSeqMap.get(maximalElement);
						//we need to add all the corresponding sequences of the abstraction node's offspring nodes
						for (PatternTreeNode offspring : offSpringNodes) {
							Set<String> offspringAlphabet = offspring.getLabelAlphabet();
							if (patAlphabetSeqMap.containsKey(offspringAlphabet)) {
								allAbstractionSequence.addAll(patAlphabetSeqMap.get(offspringAlphabet));
							} else {
								//length-1 pattern
								allAbstractionSequence.add(offspringAlphabet.toString()
										.substring(1, 1 + encodingLength));
							}
						}
						Set<String> filteredAbstractionSequence = new HashSet<String>();
						for (String seq : allAbstractionSequence) {
							//the conflict nodes will be used as the first abstraction by default
							if (!usedSeqs.contains(seq)) {
								filteredAbstractionSequence.add(seq);
							}
						}
						usedSeqs.addAll(filteredAbstractionSequence);
						selectedPatternNameSequenceMap.put(newPtnName, filteredAbstractionSequence);
						//add element in the pattern List
						patternListModel.addElement(newPtnName);

						//}
					}
					//treat every  single activitie which is not used in a pattern  as a pattern itself
					for(Set<String> singleAct : notUsedSingleActivityInPatternSet){
						String newPtnName = singleAct.toString();;
						if (oldNewPatternNameMap.containsKey(singleAct)) {
							newPtnName = oldNewPatternNameMap.get(singleAct);
						}
						selectedPatternNameSequenceMap.put(newPtnName, singleAct);
						//add element in the pattern List
						patternListModel.addElement(newPtnName);						
					}
				}

				int ii = 1;
				System.out.println("After Select All Patterns-----, the total number is " + absSeqMap.size());
				for (String newPtnName : selectedPatternNameSequenceMap.keySet()) {
					System.out.println("The No " + ii + " new pattern name is" + newPtnName);
					ii++;
				}

				patternTree.signalViews();
				wholeEditPanel.revalidate();
				wholeEditPanel.repaint();
			}
		});

		c.gridx = 0;
		c.gridy = 7;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(16, 0, 0, 15);
		desiredPatternPanel.add(selectAllRadioButton, c);

		//deselect all patterns

		deselectAllRadioButton = new JRadioButton("Deselect All Patterns");
		deselectAllRadioButton.setUI(new SlickerRadioButtonUI());
		deselectAllRadioButton.setOpaque(false);
		deselectAllRadioButton.setAlignmentX(JRadioButton.LEFT_ALIGNMENT);
		deselectAllRadioButton.setHorizontalAlignment(JRadioButton.LEFT);
		deselectAllRadioButton.setSelected(true);
		deselectAllRadioButton.setToolTipText("<html> Deselect all patterns to preprocess the log.</html>");
		deselectAllRadioButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (deselectAllRadioButton.isSelected()) {

					//all the maximalElements will be used in an abstraction mode		 
					for (Set<String> maximalElement : absSeqMap.keySet()) {
						//clear the current selection of patterns
						selectedPatternNameSequenceMap.clear();
						oldLabelsOfSelectedPatterns.clear();
						selectedPatternAlphabetNewLabel.clear();
						parentOffspringNodesMap.clear();

						//set the color of nodes in the maximalElement subgraph
						PatternTreeNode abstractionNode = getAbstractionNode(maximalElement);
						Set<PatternTreeNode> offSpringNodes = getOffspringNodes(abstractionNode);
						parentOffspringNodesMap.put(abstractionNode, offSpringNodes);
						abstractionNode.getAttributeMap().put(AttributeMap.FILLCOLOR, Color.WHITE);
						setColorOfNodesInSubTree(abstractionNode, false);

						//make every component in the EditPanel become disable
						nameField.setText("");
						nameField.setEditable(true);
						activityListModel.removeAllElements();
						activityList.setEnabled(true);
						notToUseRadioButton.setEnabled(true);
						desireNodeRadioButton.setEnabled(true);
						;
						desireSubGraphRadioButton.setEnabled(true);
						notToUseRadioButton.setSelected(true);
						patternListModel.removeAllElements();
					}

				}
				patternTree.signalViews();
				wholeEditPanel.revalidate();
				wholeEditPanel.repaint();
			}
		});

		c.gridx = 0;
		c.gridy = 8;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(16, 0, 0, 15);
		desiredPatternPanel.add(deselectAllRadioButton, c);

		ButtonGroup radioSelectGroup = new ButtonGroup();
		radioSelectGroup.add(selectAllRadioButton);
		radioSelectGroup.add(deselectAllRadioButton);

		SlickerButton transformLogButton = new SlickerButton("Transform Log Based on Patterns");
		transformLogButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				preProcessLog();
			}
		});

		c.gridx = 0;
		c.gridy = 9;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.insets = new Insets(16, 0, 0, 15);
		;
		desiredPatternPanel.add(transformLogButton, c);

	}

	private PatternTreeNode getAbstractionNode(Set<String> maximalElement) {
		Set<PatternTreeNode> nodes = patternTree.getNodes();
		for (PatternTreeNode node : nodes) {
			if (node.getLabelAlphabet().equals(maximalElement)) {
				return node;
			}
		}
		return null;
	}

	private void setOldNewPatternNameMap() {
		for (Entry<String, Set<Set<String>>> entry : newOldPatternNameMap.entrySet()) {
			String newPtnName = entry.getKey();
			Set<String> oldPtnName = entry.getValue().iterator().next();
			System.out.println("!!!The entry to put in the oldNewPatternNameMap is (" + oldPtnName + "," + newPtnName
					+ ")");
			oldNewPatternNameMap.put(oldPtnName, newPtnName);
		}
	}

	/*
	 * create initial value of the output log
	 */
	private XLog createInitialLog(XFactory factory) {
		XLog outputLog = factory.createLog();
		for (XExtension extension : log.getExtensions()) {
			outputLog.getExtensions().add(extension);
		}
		outputLog.setAttributes((XAttributeMap) log.getAttributes().clone());
		//	XAttributeLiteral logPathAttr = new XAttributeLiteral();
		return outputLog;

	}

	/*
	 * create the initial value of the output trace
	 */
	private XTrace createInitialTrace(XFactory factory, XTrace originalTrace) {
		XTrace outputTrace = factory.createTrace();
		outputTrace.setAttributes(originalTrace.getAttributes());

		for (XExtension extension : originalTrace.getExtensions()) {
			outputTrace.getExtensions().add(extension);
		}
		return outputTrace;

	}

	/*
	 * according to the user alternation, substitute the corresponding
	 * subsequences in each trace with the pattern. The transformation strategy
	 * is as follows, Firstly, find the continuous manifestation of a pattern
	 * which is longer than 2 and starts with current symbol. Secondly, if there
	 * is no continuous manifestation of any pattern, find the intermittent
	 * manifestation of a pattern which satisfied the above requirements.
	 */
	/**
	 * @return
	 */
	//	private XLog preProcessLog() {
	//
	//		XFactory factory = XFactoryRegistry.instance().currentDefault();
	//
	//		//prepare relative data for pre-processing the log
	//		int numberOfSelectedPattern = patternListModel.size();
	//		//JC Add Start
	//		System.out.println("Selected Nodes: ");
	//		for (int ii = 0; ii < numberOfSelectedPattern; ii++)
	//			System.out.println(patternListModel.get(ii));
	//		//JC Add End
	//		//Collections of all the sequences corresponding to each selected pattern
	//		Set<String> sequencesOfSelectedPatterns = new HashSet<String>();
	//		//Map the pattern sequence with the new pattern name which is used to substitute this sequence
	//		Map<String, String> sequenceNewPatternLabelMap = new HashMap<String, String>();
	//		Map<String, XLog> patternSubLogMap = new HashMap<String, XLog>();
	//		Set<String> selectedEncodedActivitySet = new HashSet<String>();
	//		Set<String> selectedDecodedActivitySet = new HashSet<String>();
	//	   if (selectAllRadioButton.isSelected()) {
	//			//use all the patterns in the pattern graph
	//			for (Set<String> maximalElement : absSeqMap.keySet()) {
	//				
	//				//if (maximalElement.size() > 1) {
	//					String newPtnName = "";
	//					Set<String> ptnSequences = new HashSet<String>();
	//					//setOldNewPatternNameMap();
	//					if (oldNewPatternNameMap.containsKey(maximalElement)) {
	//						newPtnName = oldNewPatternNameMap.get(maximalElement);
	//						System.out.println("Processing Node: " + newPtnName);
	//						System.out.println("\t" + maximalElement);
	//						selectedEncodedActivitySet.addAll(maximalElement);
	//						if (maximalElement.size() > 1) {
	//							XLog outputSubLog = createInitialLog(factory);
	//							patternSubLogMap.put(newPtnName, outputSubLog);
	//					   		ptnSequences = selectedPatternNameSequenceMap.get(newPtnName);
	//						//	System.out.println("The ptnSequences of " + newPtnName + " is " + ptnSequences);
	//							sequencesOfSelectedPatterns.addAll(ptnSequences);
	//							for (String seq : ptnSequences) {
	//								sequenceNewPatternLabelMap.put(seq, newPtnName);
	//							}
	//						}
	//					}
	//				//}
	//			}
	//		}else if(deselectAllRadioButton.isSelected()&& (numberOfSelectedPattern==0)){
	//			//we do not use the patterns,but all the acitivities in the pattern will be used
	//			//the selected activity set depends on the activity filter parameter
	//			System.out.println("Filtered Pattern Alpahbet: ");
	//			for(Set<String> alphabet : filterPatternAlphabetSet)
	//			{
	//				System.out.println("\t" + alphabet);
	//				selectedEncodedActivitySet.addAll(alphabet);
	//			}
	//			System.out.println("notUsedSingleActivityInPatternSet: ");
	//			for(Set<String> notUsedSglAct : notUsedSingleActivityInPatternSet)
	//			{
	//				System.out.println("\t" + notUsedSglAct);
	//				selectedEncodedActivitySet.addAll(notUsedSglAct);
	//			}			
	//		}else { // the user choose the desired pattern one by one
	//			for (int i = 0; i < numberOfSelectedPattern; i++) {
	//				String newPatternLabel = (String) patternListModel.get(i);
	//		    	System.out.println("Processing PatternList " + i + " : "+newPatternLabel );
	//				System.out.println("\t" + newPatternLabel);
	//			    if(!newOldPatternNameMap.containsKey(newPatternLabel))
	//			    	System.out.println("\t" + newPatternLabel);
	//				//ljf comment start for single activity pattern
	//			 //   Set<String> oldPatternAlphabet = newOldPatternNameMap.get(newPatternLabel).iterator().next();
	//				//if (oldPatternAlphabet.size() > 1) {
	//					XLog outputSubLog = createInitialLog(factory);
	//					patternSubLogMap.put(newPatternLabel, outputSubLog);
	//					//	newLabelsOfSelectedPattern.add(newPatternLabel);
	//					Set<Set<String>> oldPatternLabelSet = selectedPatternNameAlphabetMap.get(newPatternLabel);
	//					//JC Add Start
	//					System.out.println("Processing Node: " + newPatternLabel);
	//					for (Set<String> tempStringSet : oldPatternLabelSet) {
	//						System.out.println("\t" + tempStringSet);
	//						selectedEncodedActivitySet.addAll(tempStringSet);
	//					}
	//					//JC Add End
	//					//	oldLabelsOfSelectedPatterns.addAll(oldPatternLabelSet);
	//					Set<String> ptnSequences = new HashSet<String>();
	//					for (Set<String> oldPatternLabel : oldPatternLabelSet) {
	//						if (patAlphabetSeqMap.containsKey(oldPatternLabel)) {
	//							ptnSequences.addAll(patAlphabetSeqMap.get(oldPatternLabel));
	//						} else {//length-1 pattern
	//							ptnSequences.add(oldPatternLabel.toString().substring(1, 1 + encodingLength));
	//						}
	//					}
	//					//	selectedPatternNameAlphabetMap.put(newPatternLabel, oldPatternLabelSet);
	//					selectedPatternNameSequenceMap.put(newPatternLabel, ptnSequences);
	//					sequencesOfSelectedPatterns.addAll(ptnSequences);
	//					for (String seq : ptnSequences) {
	//						sequenceNewPatternLabelMap.put(seq, newPatternLabel); 
	//					}
	//				/*} else {
	//					selectedEncodedActivitySet.addAll(oldPatternAlphabet);
	//				}*/
	//			}
	//		}
	//	 //JC Add Start
	//	   System.out.println("Selected Activity Set: " + selectedEncodedActivitySet);
	//		for (String encodedActivity : selectedEncodedActivitySet)
	//			selectedDecodedActivitySet.add(charActivityMap.get(encodedActivity));
	//		FileIO io = new FileIO();
	//		io.writeToFile("C:\\Temp", "selectedDecodedActivitySet.txt", selectedDecodedActivitySet);
	//		//JC Add End
	//		
	//		//find the start symbol of the corresponding sub sequeces of each desired pattern
	//		EquivalenceClass equivalenceClass = new EquivalenceClass();
	//		Map<String, Set<String>> startSymbolSequenceOfPatternSetMap = equivalenceClass
	//				.getStartSymbolEquivalenceClassMap(encodingLength, sequencesOfSelectedPatterns);
	//		Set<String> startSymbolSequenceSet = new TreeSet<String>();
	//
	//		//create a new log according to the selected patterns
	//
	//		XLog outputLog = createInitialLog(factory);
	//		XLog outputSubLog;
	//		encodedTraceList = ptnAbsFrm.getEncodedTraceList();
	//		XTrace originalTrace;
	//		XTrace outputTrace, outputSubTrace;
	//		XEvent outputEvent;
	//		String encodedTrace, currentSymbol;
	//		String outputEncodedTrace = new String("");
	//		int encodedTraceLength, noMatches, repeatLength;
	//		int noTraces = encodedTraceList.size();
	//		Map<Integer, XEvent> patternLocationEventMap = new HashMap<Integer, XEvent>();
	//		Pattern pattern;
	//		Matcher matcher;
	//
	//		//test
	//
	//		for (int i = 0; i < noTraces; i++) {
	//			originalTrace = log.get(i);
	//			outputTrace = createInitialTrace(factory, originalTrace);
	//			encodedTrace = encodedTraceList.get(i);
	//	//			encodedTrace = "f9a8a7b7a4h2f5g5h0a2g6e9d9a5e8f4b4e1e7d2g8e4g4d3f7b2f6c6h1b6";
	//			encodedTraceLength = encodedTrace.length() / encodingLength;
	//			//comment temporarily
	//			boolean isPatternSequenceFound = false;
	//			//			System.out.println("Trace "+(i+1)+": "+encodedTrace);
	//			for (int j = 0; j < encodedTraceLength; j++) {
	//				Integer patternIdx = new Integer(j);
	//				currentSymbol = encodedTrace.substring(j * encodingLength, (j + 1) * encodingLength);
	//				//JC Add Start
	//				if (!selectedEncodedActivitySet.contains(currentSymbol))
	//					continue;
	//				//JC Add End
	//				
	//				if (startSymbolSequenceOfPatternSetMap.containsKey(currentSymbol)) {
	//					startSymbolSequenceSet = startSymbolSequenceOfPatternSetMap.get(currentSymbol);
	//					//find the continuous manifestation of the pattern
	//					for (String repeat : startSymbolSequenceSet) {
	//						////use the longer pattern first
	//						String currentPatternName = sequenceNewPatternLabelMap.get(repeat);
	//						repeatLength = repeat.length() / encodingLength;
	//					//	if(repeatLength >= 2){
	//							outputSubLog = patternSubLogMap.get(currentPatternName);
	//							pattern = Pattern.compile("(" + repeat + "){1,}");
	//							matcher = pattern.matcher(encodedTrace);
	//							//if (matcher.find(j * encodingLength) && matcher.start() == j * encodingLength) {
	//							if (matcher.find(j * encodingLength) && matcher.start() == j * encodingLength) {
	//								//find the continuous repeat
	//	
	//								isPatternSequenceFound = true;
	//							//	repeatLength = repeat.length() / encodingLength;
	//								noMatches = (matcher.end() - matcher.start()) / repeat.length();
	//							//	System.out.println("Repeat Found: "+repeat+" , length is "+repeatLength);							
	//								//add this repeat sequence as a trace to the pattern's sub-log
	//								int subSeqLength = noMatches * repeatLength;
	//								outputSubTrace = createInitialTrace(factory, originalTrace);
	//								for (int k = j; k < j + subSeqLength; k++) {
	//									XEvent ptnEvent = (XEvent) originalTrace.get(k).clone();
	//									outputSubTrace.add(ptnEvent);
	//								}
	//								outputSubLog.add(outputSubTrace);
	//								//	j += noMatches * repeatLength - 1;
	//								j += subSeqLength - 1;
	//								//add corresponding event to the pattern
	//								outputEvent = (XEvent) originalTrace.get(j).clone();
	//								if (XConceptExtension.instance() == null) {
	//									ErrorDialog.showErrorDialog(this, "Null Concept Extension");
	//								}
	//								XAttribute name = factory.createAttributeLiteral("concept:name", currentPatternName,
	//										XConceptExtension.instance());
	//								outputEvent.getAttributes().put("concept:name", name);
	//								XAttribute type = factory.createAttributeLiteral("lifecycle:transition", "complete",
	//										XConceptExtension.instance());
	//								outputEvent.getAttributes().put("lifecycle:transition", type);
	//								patternLocationEventMap.put(patternIdx, outputEvent);
	//								outputEncodedTrace += currentPatternName;
	//								outputTrace.add(outputEvent);
	//								break;
	//								//previousAbstractionName = abstractionName;
	//							}
	//						//}
	//						if (isPatternSequenceFound) {
	//							break;
	//						}
	//					}
	//					// if there is no continuous manifestation existing,try to find non-continuous pattern
	//					if(!isPatternSequenceFound)
	//					{
	//						for (String repeat : startSymbolSequenceSet) {
	//					
	//							/*
	//						 * if there is no pattern sequence starting with the
	//						 * current symbol being found, try to find whether there
	//						 * is non-continuous pattern. if there is not
	//						 * non-continuous pattern,then add the current symbol to
	//						 * the out trace
	//						 */
	//						String currentPatternName = sequenceNewPatternLabelMap.get(repeat);
	//						repeatLength = repeat.length() / encodingLength;
	//						outputSubLog = patternSubLogMap.get(currentPatternName);
	//							//if(repeatLength >= 2){
	//						//rIdx keeps the current index of the encoded trace
	//						int rIdx = patternIdx;
	//						Set<Integer> deletePtnCharPosition = new HashSet<Integer>();
	//						String curSubStringInRepeat, curSubStringInTrace;
	//						for (int m = 1 * encodingLength; m < repeatLength * encodingLength; m += encodingLength) {
	//							curSubStringInRepeat = repeat.substring(m, m + encodingLength);
	//							for (int r = rIdx + 1 * encodingLength; r < encodedTraceLength; r += encodingLength) {
	//								curSubStringInTrace = encodedTrace.substring(r, r + encodingLength);
	//								rIdx = r;
	//								if (curSubStringInRepeat.equals(curSubStringInTrace)) {
	//									deletePtnCharPosition.add(r);
	//									//m++;
	//									if (m == repeatLength * encodingLength - encodingLength) {
	//										//found a non-continuous pattern
	//										isPatternSequenceFound = true;
	//										//create new pattern event
	//									//	String currentPatternName = sequenceNewPatternLabelMap.get(repeat);
	//										System.out.println("\t "+ "Non-continous pattern Found:" + repeat + " At " + j);
	//										outputEvent = (XEvent) originalTrace.get(j).clone();
	//										if (XConceptExtension.instance() == null) {
	//											ErrorDialog.showErrorDialog(this, "Null Concept Extension");
	//										}
	//										XAttribute name = factory.createAttributeLiteral("concept:name",
	//												currentPatternName, XConceptExtension.instance());
	//										outputEvent.getAttributes().put("concept:name", name);
	//										XAttribute type = factory.createAttributeLiteral("lifecycle:transition",
	//												"complete", XConceptExtension.instance());
	//										outputEvent.getAttributes().put("lifecycle:transition", type);
	//										patternLocationEventMap.put(patternIdx, outputEvent);
	//										outputEncodedTrace += currentPatternName;
	//										outputTrace.add(outputEvent);
	//										//create sub trace of the intermittent manifestation
	//										outputSubTrace = createInitialTrace(factory, originalTrace);
	//										//add the first event of the manifestation to the sub trace
	//										XEvent ptnEvent = (XEvent) originalTrace.get(j).clone();
	//										outputSubTrace.add(ptnEvent);
	//										//add other events of the manifestation to the sub trace
	//										for (Integer p:deletePtnCharPosition) {
	//										int originalIdx = p/encodingLength;
	//											ptnEvent = (XEvent) originalTrace.get(originalIdx).clone();
	//											outputSubTrace.add(ptnEvent);
	//										}
	//										outputSubLog.add(outputSubTrace);										
	//										//change the original encode trace by deleting the chars in the non-continuous pattern 
	//										String tmpSeq = new String("");
	//										XTrace tmpTrace = factory.createTrace();
	//										tmpTrace.setAttributes(originalTrace.getAttributes());
	//
	//										for (XExtension extension : originalTrace.getExtensions())
	//											tmpTrace.getExtensions().add(extension);
	//
	//										//XTrace tmpTrace=originalTrace;
	//										for (int p = 0; p < encodedTraceLength; p++) {
	//											if (!deletePtnCharPosition.contains(p*encodingLength)) {
	//												String charString = encodedTrace.substring(p * encodingLength,
	//														(p + 1) * encodingLength);
	//												tmpSeq += charString;
	//												tmpTrace.add(originalTrace.get(p));
	//											}											
	//										}
	//										encodedTrace = tmpSeq;
	//										encodedTraceLength = encodedTrace.length() / encodingLength;
	//										originalTrace = tmpTrace;
	//									//	System.out.println("After finding the non-continuous pattern "
	//									//			+ currentPtnSeq + ", the encoded trace had became " + encodedTrace);
	//										break;
	//									} else {
	//										//rIdx += encodingLength;
	//										break;
	//									}
	//								}									
	//							}								
	//						}
	//						if (isPatternSequenceFound) {
	//							break;
	//						}
	//						} //end for
	//					}
	//						
	////						//if there is a  pattern starting with the current symbol has been found, then quit this loop	
	////						if (isPatternSequenceFound) {
	////							break;
	////						}
	////					}
	//					//there is neither continuous pattern sequence nor non-continuous pattern sequence
	//					if (!isPatternSequenceFound) {
	//						outputTrace.add(originalTrace.get(j));
	//						outputEncodedTrace += currentSymbol;
	//					}
	//					//reset the boolean value to false for next symbol
	//					isPatternSequenceFound = false;
	//				} else if (activityToFilterOutSet.contains(currentSymbol)) {//if this is an activity to filter out
	//					j++;
	//				} else {
	//					outputEncodedTrace += currentSymbol;
	//					outputTrace.add(originalTrace.get(j));
	//				}
	//			}
	//			outputLog.add(outputTrace);
	//		}
	//
	//		String transformLogFileName = "";
	//		//String savePath = "";
	//		JFileChooser fileChooser = new JFileChooser(outputDir);
	//		boolean isGivenRightName = false;
	//		while (!isGivenRightName) {
	//			int returnValue = fileChooser.showSaveDialog(this);
	//			if (returnValue == JFileChooser.APPROVE_OPTION) {
	//				File file = fileChooser.getSelectedFile();
	//				if (file.exists()) {
	//					int response = JOptionPane.showConfirmDialog(this, "Overwrite existing file?", "Confirm overwrite",
	//							JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
	//					if (response == JOptionPane.CANCEL_OPTION) {
	//						return outputLog;
	//					}
	//				} else {
	//					if (!file.getName().contains(".xes.gz")) {
	//						JOptionPane.showMessageDialog(this, "the log should be saved in the extension name '.xes.gz'!");
	//					} else {
	//						isGivenRightName = true;
	//					}
	//				}
	//				transformLogFileName = file.getAbsolutePath();
	//				isGivenRightName = true;
	//			} else if (returnValue == JFileChooser.CANCEL_OPTION) {
	//				return outputLog;
	//			}
	//		}
	//
	//		if (transformLogFileName.contains(".xes.gz")) {
	//			try {
	//
	//				FileOutputStream out = new FileOutputStream(transformLogFileName);
	//				XesXmlGZIPSerializer xesGzipSerializer = new XesXmlGZIPSerializer();
	//				xesGzipSerializer.serialize(outputLog, out);
	//				out.close();
	//			} catch (FileNotFoundException e) {
	//				ErrorDialog.showErrorDialog(this, e.getMessage());
	//			} catch (IOException e) {
	//				ErrorDialog.showErrorDialog(this, e.getMessage());
	//			}
	//
	//			String logName = transformLogFileName.replace(outputDir, "");
	//			int delimit = logName.indexOf(".");
	//			logName = logName.substring(0, delimit);
	//			String patternLogDir = outputDir + logName + "\\";
	//			File patternLogDirectory = new File(patternLogDir);
	//			if (patternLogDirectory.exists()) {
	//				PatternBasedPreprocessUtil.deleteDirectory(patternLogDirectory);
	//				patternLogDirectory.mkdir();
	//			} else {
	//				patternLogDirectory.mkdir();
	//			}
	//
	//			//output the sub log of each pattern
	//			for (String patternName : patternSubLogMap.keySet()) {
	//				String legalPatternName = PatternBasedPreprocessUtil.getLegalFileName(patternName);
	//				String legalPatternLogFileName = patternLogDir + legalPatternName + ".xes.gz";
	//				XLog patternLog = patternSubLogMap.get(patternName);
	//				try {
	//					FileOutputStream out = new FileOutputStream(legalPatternLogFileName);
	//					XesXmlGZIPSerializer xesGzipSerializer = new XesXmlGZIPSerializer();
	//					xesGzipSerializer.serialize(patternLog, out);
	//					out.close();
	//				} catch (FileNotFoundException e) {
	//					ErrorDialog.showErrorDialog(this, e.getMessage());
	//				} catch (IOException e) {
	//					ErrorDialog.showErrorDialog(this, e.getMessage());
	//				}
	//			}
	//		}
	//		return outputLog;
	//	}
	//ljf comment start  
	/*
	 * Transform the log in the following way. for each pattern, find the
	 * continuous manifestation first. if the continuous one does not exist, try
	 * to find the intermittent manifestation
	 */

	private XLog preProcessLog() {

		XFactory factory = XFactoryRegistry.instance().currentDefault();

		//prepare relative data for pre-processing the log
		int numberOfSelectedPattern = patternListModel.size();
		//JC Add Start
		System.out.println("Selected Nodes: ");
		for (int ii = 0; ii < numberOfSelectedPattern; ii++) {
			System.out.println(patternListModel.get(ii));
		}
		//JC Add End
		//Collections of all the sequences corresponding to each selected pattern
		Set<String> sequencesOfSelectedPatterns = new HashSet<String>();
		//Map the pattern sequence with the new pattern name which is used to substitute this sequence
		Map<String, String> sequenceNewPatternLabelMap = new HashMap<String, String>();
		Map<String, XLog> patternSubLogMap = new HashMap<String, XLog>();
		Set<String> selectedEncodedActivitySet = new HashSet<String>();
		Set<String> selectedDecodedActivitySet = new HashSet<String>();
		if (selectAllRadioButton.isSelected()) {
			//use all the patterns in the pattern graph
			for (Set<String> maximalElement : absSeqMap.keySet()) {

				//if (maximalElement.size() > 1) {
				String newPtnName = "";
				Set<String> ptnSequences = new HashSet<String>();
				//setOldNewPatternNameMap();
				if (oldNewPatternNameMap.containsKey(maximalElement)) {
					newPtnName = oldNewPatternNameMap.get(maximalElement);
					System.out.println("Processing Node: " + newPtnName);
					System.out.println("\t" + maximalElement);
					selectedEncodedActivitySet.addAll(maximalElement);
					if (maximalElement.size() > 1) {
						XLog outputSubLog = createInitialLog(factory);
						patternSubLogMap.put(newPtnName, outputSubLog);
						ptnSequences = selectedPatternNameSequenceMap.get(newPtnName);
						//	System.out.println("The ptnSequences of " + newPtnName + " is " + ptnSequences);
						sequencesOfSelectedPatterns.addAll(ptnSequences);
						for (String seq : ptnSequences) {
							sequenceNewPatternLabelMap.put(seq, newPtnName);
						}
					}
				}
				//}
			}
		} else if (deselectAllRadioButton.isSelected() && (numberOfSelectedPattern == 0)) {
			//we do not use the patterns,but all the acitivities in the pattern will be used
			//the selected activity set depends on the activity filter parameter
			System.out.println("Filtered Pattern Alpahbet: ");
			for (Set<String> alphabet : filterPatternAlphabetSet) {
				System.out.println("\t" + alphabet);
				selectedEncodedActivitySet.addAll(alphabet);
			}
			System.out.println("notUsedSingleActivityInPatternSet: ");
			for (Set<String> notUsedSglAct : notUsedSingleActivityInPatternSet) {
				System.out.println("\t" + notUsedSglAct);
				selectedEncodedActivitySet.addAll(notUsedSglAct);
			}
		} else { // the user choose the desired pattern one by one
			for (int i = 0; i < numberOfSelectedPattern; i++) {
				String newPatternLabel = (String) patternListModel.get(i);
				System.out.println("Processing PatternList " + i + " : " + newPatternLabel);
				System.out.println("\t" + newPatternLabel);
				if (!newOldPatternNameMap.containsKey(newPatternLabel)) {
					System.out.println("\t" + newPatternLabel);
				}
				//ljf comment start for single activity pattern
				//   Set<String> oldPatternAlphabet = newOldPatternNameMap.get(newPatternLabel).iterator().next();
				//if (oldPatternAlphabet.size() > 1) {
				XLog outputSubLog = createInitialLog(factory);
				patternSubLogMap.put(newPatternLabel, outputSubLog);
				//	newLabelsOfSelectedPattern.add(newPatternLabel);
				Set<Set<String>> oldPatternLabelSet = selectedPatternNameAlphabetMap.get(newPatternLabel);
				//JC Add Start
				System.out.println("Processing Node: " + newPatternLabel);
				for (Set<String> tempStringSet : oldPatternLabelSet) {
					System.out.println("\t" + tempStringSet);
					selectedEncodedActivitySet.addAll(tempStringSet);
				}
				//JC Add End
				//	oldLabelsOfSelectedPatterns.addAll(oldPatternLabelSet);
				Set<String> ptnSequences = new HashSet<String>();
				for (Set<String> oldPatternLabel : oldPatternLabelSet) {
					if (patAlphabetSeqMap.containsKey(oldPatternLabel)) {
						ptnSequences.addAll(patAlphabetSeqMap.get(oldPatternLabel));
					} else {//length-1 pattern
						ptnSequences.add(oldPatternLabel.toString().substring(1, 1 + encodingLength));
					}
				}
				//	selectedPatternNameAlphabetMap.put(newPatternLabel, oldPatternLabelSet);
				selectedPatternNameSequenceMap.put(newPatternLabel, ptnSequences);
				sequencesOfSelectedPatterns.addAll(ptnSequences);
				for (String seq : ptnSequences) {
					sequenceNewPatternLabelMap.put(seq, newPatternLabel);
				}
				/*
				 * } else {
				 * selectedEncodedActivitySet.addAll(oldPatternAlphabet); }
				 */
			}
		}
		//JC Add Start
		System.out.println("Selected Activity Set: " + selectedEncodedActivitySet);
		for (String encodedActivity : selectedEncodedActivitySet) {
			selectedDecodedActivitySet.add(charActivityMap.get(encodedActivity));
		}
		FileIO io = new FileIO();
		io.writeToFile("C:\\Temp", "selectedDecodedActivitySet.txt", selectedDecodedActivitySet);
		//JC Add End

		//find the start symbol of the corresponding sub sequeces of each desired pattern
		EquivalenceClass equivalenceClass = new EquivalenceClass();
		Map<String, Set<String>> startSymbolSequenceOfPatternSetMap = equivalenceClass
				.getStartSymbolEquivalenceClassMap(encodingLength, sequencesOfSelectedPatterns);
		Set<String> startSymbolSequenceSet = new TreeSet<String>();

		//create a new log according to the selected patterns

		XLog outputLog = createInitialLog(factory);
		XLog outputSubLog;
		encodedTraceList = ptnAbsFrm.getEncodedTraceList();
		XTrace originalTrace;
		XTrace outputTrace, outputSubTrace;
		XEvent outputEvent;
		String encodedTrace, currentSymbol;
		String outputEncodedTrace = new String("");
		int encodedTraceLength, noMatches, repeatLength;
		int noTraces = encodedTraceList.size();
		Map<Integer, XEvent> patternLocationEventMap = new HashMap<Integer, XEvent>();
		Pattern pattern;
		Matcher matcher;

		//test

		for (int i = 0; i < noTraces; i++) {
			originalTrace = log.get(i);
			outputTrace = createInitialTrace(factory, originalTrace);
			encodedTrace = encodedTraceList.get(i);
			//			encodedTrace = "f9a8a7b7a4h2f5g5h0a2g6e9d9a5e8f4b4e1e7d2g8e4g4d3f7b2f6c6h1b6";
			encodedTraceLength = encodedTrace.length() / encodingLength;
			if (DEBUG) {
				System.out.println("@@@@The trace to transfer is " + encodedTrace);
				System.out.println("@@@@The original length of this trace  is " + encodedTrace.length());
				System.out.println("@@@@The length of the current encodedTrace is " + encodedTraceLength);
			}
			//comment temporarily
			boolean isPatternSequenceFound = false;
			//			System.out.println("Trace "+(i+1)+": "+encodedTrace);
			for (int j = 0; j < encodedTraceLength; j++) {
				Integer patternIdx = new Integer(j);
				if (DEBUG) {
					System.out.println("@@@@The no of char being dealed with is " + j);
				}
				currentSymbol = encodedTrace.substring(j * encodingLength, (j + 1) * encodingLength);
				//JC Add Start
				if (!selectedEncodedActivitySet.contains(currentSymbol)) {
					continue;
				}

				//JC Add End
				if (startSymbolSequenceOfPatternSetMap.containsKey(currentSymbol)) {
					startSymbolSequenceSet = startSymbolSequenceOfPatternSetMap.get(currentSymbol);
					//use the longer pattern first
					for (String repeat : startSymbolSequenceSet) {
						////use the longer pattern first
						//String repeat = arrayOfSequenceWithSameStart.get(k);
						//						if(repeat.length() == encodingLength) // if the pattern contains one activity only,ignore it
						//							continue;
						String currentPatternName = sequenceNewPatternLabelMap.get(repeat);
						repeatLength = repeat.length() / encodingLength;
						outputSubLog = patternSubLogMap.get(currentPatternName);
						pattern = Pattern.compile("(" + repeat + "){1,}");
						matcher = pattern.matcher(encodedTrace);
						//if (matcher.find(j * encodingLength) && matcher.start() == j * encodingLength) {
						if (matcher.find(j * encodingLength) && (matcher.start() == j * encodingLength)) {
							//find the continuous repeat

							isPatternSequenceFound = true;
							//	repeatLength = repeat.length() / encodingLength;
							noMatches = (matcher.end() - matcher.start()) / repeat.length();
							//	System.out.println("Repeat Found: "+repeat+" , length is "+repeatLength);							
							//add this repeat sequence as a trace to the pattern's log
							int subSeqLength = noMatches * repeatLength;
							outputSubTrace = createInitialTrace(factory, originalTrace);
							for (int k = j; k < j + subSeqLength; k++) {
								XEvent ptnEvent = (XEvent) originalTrace.get(k).clone();
								outputSubTrace.add(ptnEvent);
							}
							outputSubLog.add(outputSubTrace);
							//	j += noMatches * repeatLength - 1;
							j += subSeqLength - 1;

							//	System.out.println("Repeat Found: " + repeat + " , " + noMatches + " , "
							//		+ currentPatternName);
							//add corresponding event to the pattern
							outputEvent = (XEvent) originalTrace.get(j).clone();
							if (XConceptExtension.instance() == null) {
								ErrorDialog.showErrorDialog(this, "Null Concept Extension");
							}
							XAttribute name = factory.createAttributeLiteral("concept:name", currentPatternName,
									XConceptExtension.instance());
							outputEvent.getAttributes().put("concept:name", name);
							XAttribute type = factory.createAttributeLiteral("lifecycle:transition", "complete",
									XConceptExtension.instance());
							outputEvent.getAttributes().put("lifecycle:transition", type);
							patternLocationEventMap.put(patternIdx, outputEvent);
							outputEncodedTrace += currentPatternName;
							outputTrace.add(outputEvent);
							break;
							//previousAbstractionName = abstractionName;
						} else {

							/*
							 * if there is no pattern sequence starting with the
							 * current symbol being found, try to find whether
							 * there is non-continuous pattern. if there is not
							 * non-continuous pattern,then add the current
							 * symbol to the out trace
							 */
							//r keeps the current index of the encoded trace
							//try to find non-continuous pattern

							int rIdx = patternIdx * encodingLength;
							//	for (String currentPtnSeq : startSymbolSequenceSet) {
							//total length of current pattern Sequence. e.g. the length  of "a0b0" is 4
							//	int curPtnSeqLength = currentPtnSeq.length();
							Set<Integer> deletePtnCharPosition = new TreeSet<Integer>();
							String curSubStringInRepeat, curSubStringInTrace;
							for (int m = 1 * encodingLength; m < repeatLength * encodingLength; m += encodingLength) {
								curSubStringInRepeat = repeat.substring(m, m + encodingLength);
								for (int r = rIdx + 1 * encodingLength; r < encodedTraceLength; r += encodingLength) {
									curSubStringInTrace = encodedTrace.substring(r, r + encodingLength);
									rIdx = r;
									if (curSubStringInRepeat.equals(curSubStringInTrace)) {
										deletePtnCharPosition.add(r);
										//m++;
										if (m == repeatLength * encodingLength - encodingLength) {
											//found a non-continuous pattern
											isPatternSequenceFound = true;
											//create new pattern event
											//	String currentPatternName = sequenceNewPatternLabelMap.get(repeat);
											System.out.println("\t " + "Non-continous pattern Found:" + repeat + " At "
													+ j);
											outputEvent = (XEvent) originalTrace.get(j).clone();
											if (XConceptExtension.instance() == null) {
												ErrorDialog.showErrorDialog(this, "Null Concept Extension");
											}
											XAttribute name = factory.createAttributeLiteral("concept:name",
													currentPatternName, XConceptExtension.instance());
											outputEvent.getAttributes().put("concept:name", name);
											XAttribute type = factory.createAttributeLiteral("lifecycle:transition",
													"complete", XConceptExtension.instance());
											outputEvent.getAttributes().put("lifecycle:transition", type);
											patternLocationEventMap.put(patternIdx, outputEvent);
											outputEncodedTrace += currentPatternName;
											outputTrace.add(outputEvent);

											//create sub trace of the intermittent manifestation
											outputSubTrace = createInitialTrace(factory, originalTrace);
											//add the first event of the manifestation to the sub trace
											XEvent ptnEvent = (XEvent) originalTrace.get(j).clone();
											outputSubTrace.add(ptnEvent);
											//add other events of the manifestation to the sub trace
											for (Integer p : deletePtnCharPosition) {
												int originalIdx = p / encodingLength;
												ptnEvent = (XEvent) originalTrace.get(originalIdx).clone();
												outputSubTrace.add(ptnEvent);
											}
											outputSubLog.add(outputSubTrace);

											//change the original encode trace by deleting the chars in the non-continuous pattern 
											String tmpSeq = new String("");
											XTrace tmpTrace = factory.createTrace();
											tmpTrace.setAttributes(originalTrace.getAttributes());

											for (XExtension extension : originalTrace.getExtensions()) {
												tmpTrace.getExtensions().add(extension);
											}

											//XTrace tmpTrace=originalTrace;
											for (int p = 0; p < encodedTraceLength; p++) {
												if (!deletePtnCharPosition.contains(p * encodingLength)) {
													String charString = encodedTrace.substring(p * encodingLength,
															(p + 1) * encodingLength);
													tmpSeq += charString;
													tmpTrace.add(originalTrace.get(p));
												}
											}
											encodedTrace = tmpSeq;
											encodedTraceLength = encodedTrace.length() / encodingLength;
											originalTrace = tmpTrace;
											//	System.out.println("After finding the non-continuous pattern "
											//			+ currentPtnSeq + ", the encoded trace had became " + encodedTrace);
											break;
										} else {
											//rIdx += encodingLength;
											break;
										}
									}

								}
							}
							//}
						}
						//if there is a  pattern starting with the current symbol has been found, then quit this loop	
						if (isPatternSequenceFound) {
							break;
						}
					}
					//there is neither continuous pattern sequence nor non-continuous pattern sequence
					if (!isPatternSequenceFound) {
						outputTrace.add(originalTrace.get(j));
						outputEncodedTrace += currentSymbol;
					}
					//reset the boolean value to false for next symbol
					isPatternSequenceFound = false;
				} else if (activityToFilterOutSet.contains(currentSymbol)) {//if this is an activity to filter out
					j++;
				} else {
					outputEncodedTrace += currentSymbol;
					outputTrace.add(originalTrace.get(j));
				}
			}
			outputLog.add(outputTrace);
		}

		String transformLogFileName = "";
		//String savePath = "";
		JFileChooser fileChooser = new JFileChooser(".");
		boolean isGivenRightName = false;
		while (!isGivenRightName) {
			int returnValue = fileChooser.showSaveDialog(this);
			if (returnValue == JFileChooser.APPROVE_OPTION) {
				File file = fileChooser.getSelectedFile();
				if (file.exists()) {
					int response = JOptionPane.showConfirmDialog(this, "Overwrite existing file?", "Confirm overwrite",
							JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
					if (response == JOptionPane.CANCEL_OPTION) {
						return outputLog;
					}
				} else {
					if (!file.getName().contains(".xes.gz")) {
						JOptionPane.showMessageDialog(this, "the log should be saved in the extension name '.xes.gz'!");
					} else {
						isGivenRightName = true;
					}
				}
				transformLogFileName = file.getAbsolutePath();
				isGivenRightName = true;
			} else if (returnValue == JFileChooser.CANCEL_OPTION) {
				return outputLog;
			}
		}
		
		String fileseperator = File.separator; // it can change according to the operating system
		int lastIndexofDelima = transformLogFileName.lastIndexOf(fileseperator);
        outputDir = transformLogFileName.substring(0, lastIndexofDelima+1);
        String currentTransformedLogName = transformLogFileName.substring(lastIndexofDelima+1,transformLogFileName.length());
        XAttribute curLogName = factory.createAttributeLiteral("concept:name", currentTransformedLogName,XConceptExtension.instance());   
        //add attributes to maintain the relation between the transformed log and its original log
		//create attribute "location"
        XAttribute logLocation = factory.createAttributeLiteral("fileLocation", outputDir,null);       
		String prtFileName = ((XAttributeLiteral)log.getAttributes().get("concept:name")).getValue();		
		//from the 2nd iteration of log transformation
		if(log.getAttributes().containsKey("fileLocation")){
			prtFileName = ((XAttributeLiteral)log.getAttributes().get("fileLocation")).getValue() + prtFileName;
			
		}
		//create attribute "parentFileLocation"
		XAttribute parentFileLocation = new XAttributeLiteralImpl("parentFileName",prtFileName);
		/*If the original log is a transformed log, then add the attribute of "parentFileLocation" of the original log 
		 * as the sub attributes of the attribute of the current transformed log*/
		if(log.getAttributes().containsKey("parentFileName"))
		{
			XAttributeLiteralImpl ancestorFileLoacation = (XAttributeLiteralImpl)log.getAttributes().get("parentFileName");	
			XAttributeMapImpl attMap = new XAttributeMapImpl();
			attMap.put("parentFileName", ancestorFileLoacation);
			parentFileLocation.setAttributes(attMap);
		}
		outputLog.getAttributes().put("concept:name", curLogName);
		outputLog.getAttributes().put("fileLocation", logLocation);
		outputLog.getAttributes().put("parentFileName", parentFileLocation);
		
		//System.out.println("The log location is " + outputLog.getAttributes().get("location"));
		if (transformLogFileName.contains(".xes.gz")) {
			try {

				FileOutputStream out = new FileOutputStream(transformLogFileName);
				XesXmlGZIPSerializer xesGzipSerializer = new XesXmlGZIPSerializer();
				xesGzipSerializer.serialize(outputLog, out);
				out.close();
			} catch (FileNotFoundException e) {
				ErrorDialog.showErrorDialog(this, e.getMessage());
			} catch (IOException e) {
				ErrorDialog.showErrorDialog(this, e.getMessage());
			}

			String logName = transformLogFileName.replace(outputDir, "");
			int delimit = logName.indexOf(".");
			logName = logName.substring(0, delimit);
			String patternLogDir = outputDir + logName + fileseperator;
			File patternLogDirectory = new File(patternLogDir);
			if (patternLogDirectory.exists()) {
				PatternBasedPreprocessUtil.deleteDirectory(patternLogDirectory);
				patternLogDirectory.mkdir();
			} else {
				patternLogDirectory.mkdir();
			}

			//output the sub log of each pattern
			for (String patternName : patternSubLogMap.keySet()) {
				String legalPatternName = PatternBasedPreprocessUtil.getLegalFileName(patternName);
				String legalPatternLogFileName = patternLogDir + legalPatternName + ".xes.gz";
				XLog patternLog = patternSubLogMap.get(patternName);
				XAttribute curSubLogName = factory.createAttributeLiteral("concept:name", legalPatternName + ".xes.gz",XConceptExtension.instance());
				patternLog.getAttributes().put("concept:name", curSubLogName);
				//remove the additional attribute of "fileLocation"
				if(patternLog.getAttributes().containsKey("fileLocation"))
				{
					patternLog.getAttributes().remove("fileLocation");				
				}
				//remove the additional attribute of "fileLocation"
				if(patternLog.getAttributes().containsKey("parentFileName"))
				{
					patternLog.getAttributes().remove("parentFileName");				
				}
				try {
					FileOutputStream out = new FileOutputStream(legalPatternLogFileName);
					XesXmlGZIPSerializer xesGzipSerializer = new XesXmlGZIPSerializer();
					xesGzipSerializer.serialize(patternLog, out);
					out.close();
				} catch (FileNotFoundException e) {
					ErrorDialog.showErrorDialog(this, e.getMessage());
				} catch (IOException e) {
					ErrorDialog.showErrorDialog(this, e.getMessage());
				}
			}
		}
		
		//push the outputLog into the framework
	   context.getProvidedObjectManager().createProvidedObject(currentTransformedLogName,
				outputLog, XLog.class,context);						  
		/*
		 * Make the resulting log a favorite, if possible.
		 */
		if (context instanceof UIPluginContext) {
			((UIPluginContext) context).getGlobalContext().getResourceManager().getResourceForInstance(outputLog)
					.setFavorite(true);
		}
		return outputLog;
	}

	//ljf comment end

	private void findTheCorrespondingPatterNode(String nodeLabel) {
		for (PatternTreeNode node : patternTree.getNodes()) {
			if (node.getNameToEdit().equals(nodeLabel)) {
				selectedPatternNode = node;
				node.getAttributeMap().put(AttributeMap.EDGECOLOR, Color.red);
				patternTree.graphElementChanged(node);
				patternTree.signalViews();
				//graphPanel.getGraph().set
				break;
			}
		}
	}
}
